unit Jed_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Menus, GlobalVars, J_Level, misc_utils, ExtCtrls,
  Render, OGL_render, FileOperations, lev_utils, Geometry,
  Buttons, Math, Containers, Files, U_templates,Prefab, ListRes,
  Sft_render;

Const
     {Map modes}
     MM_SC=0;
     MM_SF=1;
     MM_VX=2;
     MM_TH=3;
     MM_ED=4;
     MM_LT=5;

     {Mouse Modes}
     MM_Select=0;
     MM_Cleave=1;
     MM_Drag=2;
     MM_TranslateCam=3;
     MM_RotateCam=4;
     MM_TranslateGrid=5;
     MM_RotateGrid=6;
     MM_CreateSector=7;

     All_layers=-100;

     {Toolbar Panel IDs}
     PI_XYZ=0;

     {ShiftTexture constants}
     st_left=0;
     st_right=1;
     st_up=2;
     st_down=3;

     {SectorChanged() constants}
     sc_vertices=1;
     sc_values=2;
     sc_all=-1;

     ro_up=0;
     ro_down=1;
     {Cursor constants}
     crSaber=1;

     {SetThingView constants}
      cv_Dots=0;
      cv_Boxes=1;
      cv_Wireframes=2;

type
  TJedMain = class(TForm)
    MainMenu: TMainMenu;
    FileMenu: TMenuItem;
    Exit1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    RecentBar: TMenuItem;
    Help1: TMenuItem;
    Topics1: TMenuItem;
    About1: TMenuItem;
    N2: TMenuItem;
    Save1: TMenuItem;
    Import1: TMenuItem;
    SaveJKL: TSaveDialog;
    Export1: TMenuItem;
    Tools1: TMenuItem;
    CalculateLights1: TMenuItem;
    ConsistencyCheck1: TMenuItem;
    Tbar: TPanel;
    BNSC: TSpeedButton;
    BNSF: TSpeedButton;
    BNVX: TSpeedButton;
    BNTH: TSpeedButton;
    BNLT: TSpeedButton;
    BNED: TSpeedButton;
    ToolWindow1: TMenuItem;
    PlcedCogs1: TMenuItem;
    ItemEditor1: TMenuItem;
    Commands1: TMenuItem;
    MUNextObject: TMenuItem;
    MUPrevObject: TMenuItem;
    MUSnapGridTo: TMenuItem;
    SaveJed: TSaveDialog;
    Options1: TMenuItem;
    GobProject1: TMenuItem;
    SaveGOB: TSaveDialog;
    SaveJKL1: TMenuItem;
    Viewtogrid1: TMenuItem;
    Toolbar1: TMenuItem;
    JedTutor1: TMenuItem;
    N3DPreview1: TMenuItem;
    SaveAs1: TMenuItem;
    Panel1: TPanel;
    PXYZ: TPanel;
    PMsg: TPanel;
    Messages1: TMenuItem;
    LBXYZ: TLabel;
    SaveJKLGob1: TMenuItem;
    GridtoView1: TMenuItem;
    Edit1: TMenuItem;
    Find1: TMenuItem;
    FindNext1: TMenuItem;
    Levelheadereditor1: TMenuItem;
    View1: TMenuItem;
    ViewthingsAs1: TMenuItem;
    Dots: TMenuItem;
    Boxes: TMenuItem;
    Wireframes: TMenuItem;
    NewMOTSProject1: TMenuItem;
    PNProjType: TPanel;
    EpisodeEditor1: TMenuItem;
    CheckResources1: TMenuItem;
    Save3DO: TSaveDialog;
    N1: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    ExportSectoras3DO1: TMenuItem;
    ReloadTemplates1: TMenuItem;
    MakeaBackupCopy1: TMenuItem;
    Onvisiblelayers1: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Import1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Export1Click(Sender: TObject);
    procedure PlaceCogs1Click(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure CalculateLights1Click(Sender: TObject);
    procedure ConsistencyCheck1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure BNSCClick(Sender: TObject);
    procedure ItemEditor1Click(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MUNextObjectClick(Sender: TObject);
    procedure MUPrevObjectClick(Sender: TObject);
    procedure MUSnapGridToClick(Sender: TObject);
    procedure ToolWindow1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure GobProject1Click(Sender: TObject);
    procedure SaveJKL1Click(Sender: TObject);
    procedure Viewtogrid1Click(Sender: TObject);
    procedure Toolbar1Click(Sender: TObject);
    procedure Topics1Click(Sender: TObject);
    procedure JedTutor1Click(Sender: TObject);
    procedure N3DPreview1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure PMsgDblClick(Sender: TObject);
    procedure Messages1Click(Sender: TObject);
    procedure SaveJKLGob1Click(Sender: TObject);
    procedure GridtoView1Click(Sender: TObject);
    procedure Find1Click(Sender: TObject);
    procedure FindNext1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Levelheadereditor1Click(Sender: TObject);
    procedure WireframesClick(Sender: TObject);
    procedure NewMOTSProject1Click(Sender: TObject);
    procedure PNProjTypeDblClick(Sender: TObject);
    procedure EpisodeEditor1Click(Sender: TObject);
    procedure CheckResources1Click(Sender: TObject);
    procedure ExportSectoras3DO1Click(Sender: TObject);
    procedure ReloadTemplates1Click(Sender: TObject);
    procedure MakeaBackupCopy1Click(Sender: TObject);
    procedure Onvisiblelayers1Click(Sender: TObject);
  public
    {Project vars}
    AskSaveAs:boolean;
    NewLevel:boolean;
    LevelFile:String;
    Changed:boolean;
    {}
    SnapToGrid:boolean;
    renderer:TRenderer;
    ListID:Integer;
    hdc,hglc:integer;
    scale:double;
    Cur_SC,
    Cur_SF,
    Cur_VX,
    Cur_ED,
    Cur_LT,
    Cur_TH:Integer;
    Map_mode:integer;
    Mouse_mode:integer;
    thing_view:integer;
    { Private declarations }
    {Select vars}
    LastSelXY:TPoint;
    csel:integer;
    {Drag variables}
    dragged:boolean;
    DragOrg:T3DPoint;
    {Cleave vars}
    CleaveOrgXY:TPoint;
    CleaveOrg:T3DPoint;
    CleaveStarted:boolean;
    SCCreateStarted:boolean;
    LastX,LastY:Integer;

    {Grid translate vars}
    GOrgXY:TPoint;
    GOrg:T3DPoint;
    {Cam translate}
    CamOrg:TPoint;
    {Stitch variables}
    stitch_Sec:TJKSector;
    stitch_Surf:TJKSurface;

    tcube:TPolygons;

    Procedure WMEraseBkg(var msg:TMessage); message WM_ERASEBKGND;
    Procedure WMQueryPal(var msg:TMessage); message WM_QUERYNEWPALETTE;
    Procedure WMPalCHANGED(var msg:TMessage);message WM_PALETTECHANGED;
    procedure RecentClick(Sender: TObject);
  public
    Procedure NewProject;
    Procedure OpenProject(const fname:string);
    Function SaveProject:boolean;
    Function SysSaveProject(askSave:Boolean):boolean;
    Procedure SaveToJKL(const fname:string);
    Procedure SnapGridToObject;
    Function GetXYZAt(atX,atY:integer;var X,Y,Z:double):boolean;
    Function GetMousePos(var X,Y:integer):boolean;

    Procedure Do_SelectAt(X,Y:integer);

    Procedure Do_StartCleave(X,Y:integer;snaptovertex:boolean);
    Procedure Do_ProceedCleave(X,Y:integer;snaptovertex:boolean);
    Procedure Do_EndCleave(X,Y:integer;snaptovertex:boolean);

    Procedure Do_StartDrag(X,Y:integer);
    Procedure Do_ProceedDrag(X,Y:integer;snaptovx:boolean);
    Procedure Do_EndDrag(X,Y:Integer);

    Procedure Do_StartTranslateCam(X,Y:integer);
    Procedure Do_TranslateCam(X,Y:integer);

    Procedure Do_StartRotateCam(X,Y:integer);
    Procedure Do_RotateCam(X,Y:integer);

    Procedure Do_StartTranslateGrid(X,Y:integer);
    Procedure Do_TranslateGrid(X,Y:integer);

    Procedure Do_StartRotateGrid(X,Y:integer);
    Procedure Do_RotateGrid(X,Y:integer);

    Procedure DO_StartCreateSC(X,Y:integer;snaptovertex:boolean);
    Procedure DO_ProceedCreateSC(X,Y:integer;snaptovertex:boolean);
    Procedure DO_EndCreateSC(X,Y:integer;snaptovertex:boolean);

    Procedure ResetEditor;
    Procedure SetLevelName;
    Procedure ReDraw;
    Procedure DrawThing(th:TThing);
    Procedure DrawSelThing(th:TThing);

    Procedure SetMouseMode(mm:integer);
    Procedure SetMapMode(mm:integer);
    Procedure SetCurSC(SC:integer);
    Procedure SetCurSF(SC,SF:integer);
    Procedure SetCurVX(SC,VX:integer);
    Procedure SetCurED(SC,SF,ED:integer);
    Procedure SetCurLT(LT:integer);
    Procedure SetCurTH(TH:integer);
    Procedure AddLightAt(x,y:integer);
    Procedure AddThingAt(x,y:integer);
    Procedure AddSectorAt(X,Y:integer);
    Procedure CopySectorAt(X,Y:integer);
    Procedure NextObject;
    Procedure PreviousObject;
    Procedure NextObjectInSurface;
    Procedure PreviousObjectInSurface;
    Procedure EditObject;
    Procedure GotoSC(sc:integer);
    Procedure GotoSF(sc,sf:integer);
    Procedure GotoTH(th:Integer);
    Procedure LayerThing(n:integer);
    Procedure CancelMouseMode;
    Procedure Goto_Adjoin;
    Procedure SetViewToGrid;
    Procedure SetGridToView;
    Procedure ShiftTexture(how:integer);
    Procedure RotateTexture(how:integer);
    {Notification procedures}
    Procedure SectorChanged(s:TJKSector);
    Procedure SectorAdded(s:TJKSector);
    Procedure SectorDeleted(s:TJKSector);
    Procedure ThingChanged(th:TJKThing);
    Procedure ThingAdded(th:TJKThing);
    Procedure ThingDeleted(th:TJKThing);

    Procedure RotateObject(angle:double; axis:integer);
    Procedure ScaleObject(sfactor:double);
    Procedure TranslateObject(dx,dy,dz:double);
    Procedure MakeDoor;
    Procedure StartStitch;
    Procedure DoStitch;
    Procedure StraightenTexture(zero,rot90:boolean);
    Procedure SetCam(X,Y,Z,PCH,YAW,ROL:Double);
    Procedure RaiseObject(how:integer);
    Function IsSelValid:boolean;
    Procedure VerifySelection;
    Procedure SyncRecents;
    Procedure AddRecent(const s:string);
    Procedure LevelChanged;
    Function AskSave:boolean;
    Procedure SetThingView(how:integer);
    Procedure UpdateThingData(th:TJKThing);
    Procedure LoadTemplates;
    Procedure SetMotsIndicator;
    Function ShortJKLName:string;
  end;

var
  JedMain: TJedMain;

Procedure LoadThing3DO(th:TJKThing;force:boolean);

implementation

uses Item_edit, U_CogForm, Cons_checker, FileDialogs, U_Tools,
  U_Options, Jed_about1, ProgressDialog, U_tbar, U_Preview, U_msgForm,
  Q_Sectors, Q_surfs, Q_things, U_lheader, U_3DOs, values, U_Medit, u_DFI;

Procedure TJedMain.WMEraseBkg(var msg:TMessage);
begin
 msg.Result:=0;
end;

Procedure TJedMain.WMQueryPal(var msg:TMessage);
begin
 msg.Result:=Renderer.HandleWMQueryPal;
end;

Procedure TJedMain.WMPalCHANGED(var msg:TMessage);
begin
 msg.Result:=Renderer.HandleWMChangePal;
end;


{$R *.DFM}

procedure TJedMain.Exit1Click(Sender: TObject);
begin
 Application.Terminate;
end;

Procedure TJedMain.NewProject;
var sec:TJKSector;
    surf:TJKSurface;
    v:TJKVertex;
    th:TJKThing;
    lt:TJedLight;
    i:integer;
begin
 for i:=0 to Level.Things.Count-1 do
 Free3DO(Level.Things[i].a3DO);

 Level.Clear;
 sec:=Level.NewSector;
 Level.Sectors.Add(sec);

 v:=sec.newVertex; v.x:=-1; v.y:=1; v.z:=0;
 v:=sec.newVertex; v.x:=-1; v.y:=-1; v.z:=0;
 v:=sec.newVertex; v.x:=1; v.y:=-1; v.z:=0;
 v:=sec.newVertex; v.x:=1; v.y:=1; v.z:=0;

 v:=sec.newVertex; v.x:=-1; v.y:=1; v.z:=1;
 v:=sec.newVertex; v.x:=1; v.y:=1; v.z:=1;
 v:=sec.newVertex; v.x:=1; v.y:=-1; v.z:=1;
 v:=sec.newVertex; v.x:=-1; v.y:=-1; v.z:=1;

 With Sec do
 begin
 surf:=NewSurface; sec.surfaces.Add(surf); surf.surfflags:=surf.surfflags or SF_Floor;
 Surf.AddVertex(vertices[0]);Surf.AddVertex(vertices[1]);Surf.AddVertex(vertices[2]);Surf.AddVertex(vertices[3]);
 surf:=NewSurface; sec.surfaces.Add(surf);
 Surf.AddVertex(vertices[4]);Surf.AddVertex(vertices[5]);Surf.AddVertex(vertices[6]);Surf.AddVertex(vertices[7]);

 surf:=NewSurface; sec.surfaces.Add(surf);
 Surf.AddVertex(vertices[2]);Surf.AddVertex(vertices[6]);Surf.AddVertex(vertices[5]);Surf.AddVertex(vertices[3]);

 surf:=NewSurface; sec.surfaces.Add(surf);
 Surf.AddVertex(vertices[1]);Surf.AddVertex(vertices[7]);Surf.AddVertex(vertices[6]);Surf.AddVertex(vertices[2]);

 surf:=NewSurface; sec.surfaces.Add(surf);
 Surf.AddVertex(vertices[0]);Surf.AddVertex(vertices[4]);Surf.AddVertex(vertices[7]);Surf.AddVertex(vertices[1]);

 surf:=NewSurface; sec.surfaces.Add(surf);
 Surf.AddVertex(vertices[3]);Surf.AddVertex(vertices[5]);Surf.AddVertex(vertices[4]);Surf.AddVertex(vertices[0]);
 end;

 th:=Level.NewThing; Level.Things.Add(th);
 With th do
 begin
  x:=0; y:=0; z:=0.1;
  name:='walkplayer';
  sec:=Level.Sectors[0];
 end;

 lt:=Level.NewLight; Level.Lights.Add(lt);
 With lt do begin x:=0; y:=0; z:=0.5; end;

 for i:=0 to sec.surfaces.count-1 do
 sec.surfaces[i].RecalcAll;

 sec.Renumber;

 Level.SetDefaultHeader;

 AskSaveAs:=true;
 NewLevel:=true;
 LevelFile:='Untitled.jed';
 Level.AddMissingLayers;
 level.mots:=isMots;
end;

Procedure TJedMain.OpenProject(const fname:string);
var ext:string;
    i:integer;
begin
 for i:=0 to Level.Things.Count-1 do
  Free3DO(Level.Things[i].a3DO);
 ext:=UpperCase(ExtractExt(FName));
 MsgForm.msgs.Clear;
 PMsg.Caption:='';
 if ext='.JKL' then
 begin
  NewLevel:=false;
  LevelFile:=Fname;
  AskSaveAs:=IsInContainer(Fname);
  SetLevelName;
  Level.LoadFromJKL(FName);
 end
 else if ext='.JED' then
 begin
  NewLevel:=false;
  LevelFile:=Fname;
  AskSaveAs:=IsInContainer(Fname);
  SetLevelName;
  Level.LoadFromJED(FName);
 end;
  SetMots(level.Mots);
  Level.JKLPostLoad;
  AddRecent(fname);
  ResetEditor;
  Invalidate;
end;

procedure TJedMain.SaveAs1Click(Sender: TObject);
begin
 SysSaveProject(true);
end;

Function TJedMain.SaveProject:boolean;
begin
 Result:=SysSaveProject(askSaveAs);
end;


Function TJedMain.SysSaveProject(askSave:Boolean):boolean;
var fpath,fname:string;
    t:TextFile;
begin
 Result:=false;
 if not askSave then
 begin
  fname:=ChangeFileExt(LevelFile,'.jed');
  BackUpFile(fname);
 end
 else
 begin
  SaveJed.FileName:=ChangeFileExt(ExtractName(LevelFile),'.jed');
  if not SaveJed.Execute then exit;
  fname:=SaveJed.FileName;
 end;
  fpath:=ExtractFilePath(fname);
  if not FileExists(fpath+'episode.jk') then
  begin
   AssignFile(t,fpath+'episode.jk');Rewrite(t);
   WriteLn(t,Format(EpisodeJKTpl,[ChangeFileExt(ExtractName(fname),'.jkl')]));
   CloseFile(t);
  end;
  Level.SaveToJed(fname);
  AskSaveAs:=false;
  NewLevel:=false;
  Changed:=false;
  LevelFile:=fname;
  AddRecent(fname);
  SetLevelName;
  Result:=true;
end;

Procedure TJedMain.SaveToJKL(const fname:string);
begin
end;

procedure TJedMain.Open1Click(Sender: TObject);
begin
 if Not AskSave then exit;
 With GetFileOpen do
 begin
  Filter:='All acceptable files|*.JKL;*.JED;*.GOB;*.GOO|Jed files(*.JED)|*.JED|JK Files (*goo;*.gob;*.jkl)|*.GOO;*.GOB;*.JKL';
 If Execute then OpenProject(FileName);
 end;
end;

Procedure BoxToPolys(const box:TThingBox;cube:TPolygons);
begin
  With Cube,box do
  begin
   With VXList[0] do begin x:=x1; y:=y2; z:=z1; end;
   With VXList[1] do begin x:=x1; y:=y1; z:=z1; end;
   With VXList[2] do begin x:=x2; y:=y1; z:=z1; end;
   With VXList[3] do begin x:=x2; y:=y2; z:=z1; end;

   With VXList[4] do begin x:=x1; y:=y2; z:=z2; end;
   With VXList[5] do begin x:=x2; y:=y2; z:=z2; end;
   With VXList[6] do begin x:=x2; y:=y1; z:=z2; end;
   With VXList[7] do begin x:=x1; y:=y1; z:=z2; end;
end;
end;

Procedure TJedMain.DrawThing(th:TThing);
var i:integer;
begin
  With th do Renderer.DrawVertex(X,Y,Z);
 case thing_view of
  cv_dots: exit;
  cv_boxes:
  begin
    if th.bbox.x1=th.bbox.x2 then exit;
    BoxToPolys(th.bbox,tcube);
    With th do Renderer.DrawPolygonsAt(tcube,x,y,z,pch,yaw,rol);
  end;
  cv_wireframes:
  begin
   if th.a3Do=nil then exit;
   for i:=0 to th.a3Do.Meshes.Count-1 do
   With th.a3Do.Meshes[i],th do
    Renderer.DrawPolygonsAt(Faces,x,y,z,pch,yaw,rol);
  end;
 end;
end;


Procedure TJedMain.DrawSelThing(th:TThing);
var d:Tvector;
    v1,v2:TJKVertex;
    size:double;
    i:integer;
    mx:TMat3x3;
begin
  DrawThing(th);
  d.dx:=0; d.dy:=0.2; d.dz:=0;
  CreateRotMatrix(mx,th.pch,th.yaw,th.rol);
{  RotateVector(d,th.pch,th.yaw,th.rol);}
  With d do MultVM3(mx,dx,dy,dz);

  v1:=TJKVertex.Create;
  v2:=TJKVertex.Create;

  v1.x:=th.x; v1.y:=th.y; v1.z:=th.z;

  v2.x:=v1.x+d.dx;
  v2.y:=v1.y+d.dy;
  v2.z:=v1.z+d.dz;
  Renderer.DrawLine(v1,v2);
  v1.free; v2.free;
end;

Procedure TJedMain.ReDraw;
var s,sf,th:integer;
    v1,v2:TJKVertex;
    sec:TJKSector;
    surf:TJKSurface;
    Thing:TJKThing;
    light:TJedLight;
    en:TVector;
    dx,dy,dz:double;
    bbox,cbox:TBox;
begin
 if not visible then exit;
 With clMapBack do Renderer.SetColor(CL_Background,r,g,b);
 Renderer.BeginScene;
 With clGrid do Renderer.SetColor(CL_Front,r,g,b);
 Renderer.SetPointSize(1);
 Renderer.DrawGrid;

 if map_mode=MM_VX then
 begin
  Renderer.SetPointSize(4);
  With clVertex do Renderer.SetColor(CL_Front,r,g,b);

 for s:=0 to Level.Sectors.Count-1 do
 begin
  sec:=level.Sectors[s];
  if Toolbar.IsLayerVisible(sec.Layer) then Renderer.DrawVertices(Sec.Vertices);
 end;
  Renderer.SetPointSize(1);
 end;

 Renderer.SetRenderStyle(DRAW_WIREFRAME);
 With clMapGeoBack do Renderer.SetColor(CL_Front,r,g,b);

 for s:=0 to Level.Sectors.Count-1 do
 begin
  Sec:=level.Sectors[s];
  if not Toolbar.IsLayerVisible(sec.Layer) then continue;
  for sf:=0 to sec.surfaces.count-1 do
  begin
   surf:=sec.surfaces[sf];
   surf.Mark:=Ord(Renderer.IsPolygonFacing(surf));
   if surf.Mark=1 then Renderer.DrawPolygon(surf);
  end;
 end;

 With clMapGeo do Renderer.SetColor(CL_Front,r,g,b);

 for s:=0 to Level.Sectors.Count-1 do
 begin
  Sec:=level.Sectors[s];
  if not Toolbar.IsLayerVisible(sec.Layer) then continue;
  for sf:=0 to sec.surfaces.count-1 do
  begin
   surf:=sec.surfaces[sf];
   if surf.Mark=0 then Renderer.DrawPolygon(surf);
  end;
 end;


 With clThing do Renderer.SetColor(cl_front,r,g,b);
 Renderer.SetPointSize(4);
 for th:=0 to Level.Things.Count-1 do
 begin
  Thing:=Level.Things[th];
  if Toolbar.IsLayerVisible(Thing.Layer) then
    DrawThing(Thing);
 end;


 With clLight do Renderer.SetColor(cl_front,r,g,b);
 For th:=0 to Level.Lights.Count-1 do
 begin
  light:=Level.Lights[th];
  if Toolbar.IsLayerVisible(Light.Layer) then With light do Renderer.DrawVertex(X,Y,Z);
 end;


 With clMapSel do Renderer.SetColor(CL_Front,r,g,b);
 With clMapSelBack do Renderer.SetColor(CL_Back,r,g,b);
 if IsSelValid then
 case Map_mode of
  MM_SC: begin
          sec:=level.Sectors[Cur_SC];
          Renderer.DrawPolygons(sec.surfaces);
          With sec.Vertices[0] do Renderer.DrawVertex(x,y,z);
         end;
  MM_SF: begin
          Renderer.DrawPolygon(level.Sectors[Cur_SC].surfaces[Cur_SF]);
          With level.Sectors[Cur_SC].surfaces[Cur_SF].Vertices[0] do Renderer.DrawVertex(x,y,z);
{          v1:=TJKVertex.Create;
          With level.Sectors[Cur_SC].surfaces[Cur_SF] do
          With Vertices[0] do
          begin
           v1.x:=x+normal.dx*0.2;
           v1.y:=y+normal.dy*0.2;
           v1.z:=z+normal.dz*0.2;
           Renderer.DrawLine(vertices[0],v1);
          end;
          v1.free;}
         end;
  MM_ED: With Level.Sectors[Cur_SC].Surfaces[Cur_SF] do
         begin
          v1:=Vertices[Cur_ED];
          v2:=Vertices[NextVx(Cur_ED)];
          Renderer.DrawLine(v1,v2);
          Renderer.SetPointSize(4);
          Renderer.DrawVertex(v1.x,v1.y,v1.z);
          dx:=v2.x-v1.x; dy:=v2.y-v1.y; dz:=v2.z-v1.z;
          v2:=TJKVertex.Create;
          v2.x:=v1.x+dx*0.5; v2.y:=v1.y+dy*0.5; v2.z:=v1.z+dz*0.5;
          VMult(normal.dx,normal.dy,normal.dz,dx,dy,dz,en.dx,en.dy,en.dz);
          v1:=TJKVertex.Create;
          v1.x:=v2.x+en.dx*0.5; v1.y:=v2.y+en.dy*0.5; v1.z:=v2.z+en.dz*0.5;
          Renderer.DrawLine(v2,v1);
          v1.free; v2.free;
         end;
  MM_TH: DrawSelThing(Level.Things[Cur_TH]);
  MM_VX: With level.Sectors[Cur_SC].Vertices[Cur_VX] do
          Renderer.DrawVertex(x,Y,z);
  MM_LT: if Cur_LT<Level.Lights.Count then
          With Level.Lights[Cur_LT] do
           Renderer.DrawVertex(x,y,z);

 end;
  Renderer.EndScene;
end;

procedure TJedMain.FormCreate(Sender: TObject);
var sec:TJKSector;
    surf:TJKSurface;
    vx:TJKVertex;
    p:TPolygon;
    v:Tvertex;
    i:integer;
begin
 MUSnapGridTo.ShortCut:=ShortCut(Ord('S'),[ssShift]);
 onvisiblelayers1.ShortCut:=ShortCut(Ord('L'),[ssCtrl,ssShift]);
 Renderer:=TOGLRenderer.Create(self);
{ Renderer.CamZ:=-25;}
 level.Sectors.Add(Level.NewSector);
 scale:=1;

 NewProject;
 SetWinPos(Self,MWinPos);

 tcube:=TPolygons.Create;
 tcube.VXList:=Tvertices.Create;
 for i:=1 to 8 do tcube.VXList.Add(TVertex.Create);

 With TCube do
 begin
  p:=TPolygon.Create; Add(p);
  p.AddVertex(VXList[0]);p.AddVertex(VXList[1]);p.AddVertex(VXList[2]);p.AddVertex(VXList[3]);
  p:=TPolygon.Create; Add(p);
  p.AddVertex(VXList[4]);p.AddVertex(VXList[5]);p.AddVertex(VXList[6]);p.AddVertex(VXList[7]);
  p:=TPolygon.Create; Add(p);
  p.AddVertex(VXList[2]);p.AddVertex(VXList[6]);p.AddVertex(VXList[5]);p.AddVertex(VXList[3]);
  p:=TPolygon.Create; Add(p);
  p.AddVertex(VXList[1]);p.AddVertex(VXList[7]);p.AddVertex(VXList[6]);p.AddVertex(VXList[2]);
  p:=TPolygon.Create; Add(p);
  p.AddVertex(VXList[0]);p.AddVertex(VXList[4]);p.AddVertex(VXList[7]);p.AddVertex(VXList[1]);
  p:=TPolygon.Create; Add(p);
  p.AddVertex(VXList[3]);p.AddVertex(VXList[5]);p.AddVertex(VXList[4]);p.AddVertex(VXList[0]);
end;
Screen.Cursors[crSaber]:=LoadCursor(HInstance,PChar('SABER'));
end;

procedure TJedMain.Save1Click(Sender: TObject);
begin
 SaveProject;
end;

procedure TJedMain.FormResize(Sender: TObject);
begin
 Renderer.SetViewPort(0,0,ClientWidth,Clientheight);
end;

procedure TJedMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var  th:TJKThing;
     x,y:integer;
     n,xn:TVector;
     dx,dy,dz:double;
     nx,ny,nz:TVector;
     surf,surf1:TJKSurface;
     sec,sec1:TJKSector;
begin
 if Shift=[ssShift] then
 begin
 case key of
  Ord('1')..Ord('6'):
  With Renderer do
  Case char(key) of
   '1': begin PCH:=-90; YAW:=0; ROL:=0; SetGridNormal(0,0,1); SetGridXNormal(1,0,0); end;
   '2': begin PCH:=0; YAW:=180; ROL:=0; SetGridNormal(0,1,0); SetGridXNormal(0,0,1); end;
   '3': begin PCH:=0; YAW:=-90; ROL:=0; SetGridNormal(1,0,0); SetGridXNormal(0,1,0); end;
   '4': begin PCH:=90; YAW:=0; ROL:=0; SetGridNormal(0,0,-1); SetGridXNormal(-1,0,0); end;
   '5': begin PCH:=0; YAW:=0; ROL:=0; SetGridNormal(0,-1,0); SetGridXNormal(0,0,-1); end;
   '6': begin PCH:=0; YAW:=90; ROL:=0; SetGridNormal(-1,0,0); SetGridXNormal(0,-1,0); end;
  end;
  Ord('C'): if GetMousePos(X,Y) then
            With Renderer do
            begin
              SetVec(ny,0,1,0);
              RotateVector(ny,pch,yaw,rol);
              if not GetXYZonPlaneAt(X,Y,ny,CamX,CamY,CamZ,dx,dy,dz) then exit;
              CamX:=-dX;
              CamY:=-dy;
              CamZ:=-dz;
              Self.scale:=Self.scale/1.5;
              Renderer.Scale:=Self.scale;
            end;
            { if GetXYZAt(X,Y,dx,dy,dz) then
             with Renderer do
             begin
              CamX:=-dX;
              CamY:=-dy;
              CamZ:=-dz;
              Self.scale:=Self.scale/1.5;
              Renderer.Scale:=Self.scale;
             end;}
  Ord('N'): NextObjectInSurface;
  Ord('P'): PreviousObjectInSurface;
  VK_RIGHT,VK_LEFT,VK_UP,VK_DOWN,VK_NEXT,VK_PRIOR:
  With Renderer do
  begin
  { SetVec(nx,1,0,0);
   SetVec(ny,0,1,0);
   SetVec(nz,0,0,1);
   RotatePoint(0,0,0,nx.dx,nx.dy,nx.dz,PCH,ny.dx,ny.dy,ny.dz);
   RotatePoint(0,0,0,nx.dx,nx.dy,nx.dz,PCH,ny.dz,nz.dy,nz.dz);

   RotatePoint(0,0,0,ny.dx,ny.dy,ny.dz,YAW,nx.dx,nx.dy,nx.dz);
   RotatePoint(0,0,0,ny.dx,ny.dy,ny.dz,YAW,nz.dx,nz.dy,nz.dz);

   RotatePoint(0,0,0,nz.dy,nz.dy,nz.dz,ROL,nx.dx,nx.dy,nx.dz);
   RotatePoint(0,0,0,nz.dy,nz.dy,nz.dz,ROL,ny.dx,ny.dy,ny.dz);}

  case key of
   VK_RIGHT: With Renderer do ROL:=ROL-10;
   VK_LEFT: With Renderer do ROL:=ROL+10;
   VK_UP: With Renderer do PCH:=PCH-10;
  VK_DOWN: With Renderer do PCH:=PCH+10;
  VK_PRIOR: With Renderer do Yaw:=Yaw-10;
  VK_NEXT: With Renderer do Yaw:=Yaw+10;

  end;
  Invalidate;
  exit;
  end;
  VK_INSERT: DoStitch;
  188: ShiftTexture(st_up); {<}
  190: ShiftTexture(st_down); {>}
  191: StraightenTexture(false,true); {/}
  Ord('A'): if Map_mode=MM_TH then LayerThing(Cur_TH);
  Ord('F'): Goto_Adjoin;
  Ord('W'): SnapGridToObject;
  else exit;
 end;
  Key:=0;
  Invalidate;
  exit;
 end;

 if shift=[ssAlt] then
 begin
  n:=Renderer.gnormal;
  xn:=Renderer.gxnormal;

 case key of
  Ord('A'): case map_mode of
            MM_SF:begin
              surf:=Level.Sectors[Cur_SC].Surfaces[Cur_SF];
              surf1:=surf.adjoin;
              if UnAdjoin(surf) then
              begin
               SectorChanged(surf.sector);
               SectorChanged(surf1.sector);
               SetCurSF(Cur_SC,Cur_SF);
               PanMessage(mt_info,'1 adjoin removed');
              end;
             end;
           end;

{  VK_RIGHT : begin n.dx:=Cos(Arccos(n.dx)+0.3); xn.dx:=Cos(Arccos(xn.dx)+0.3); end;
  VK_LEFT: begin n.dx:=Cos(Arccos(n.dx)-12/pi); xn.dx:=Cos(Arccos(xn.dx)-12/pi); end;
  VK_UP: With Renderer do PCH:=PCH+10;
  VK_DOWN: With Renderer do PCH:=PCH-10;
  VK_NEXT: With Renderer do ROL:=ROL+10;
  VK_PRIOR: With Renderer do ROL:=ROL-10;}
{  VK_INSERT: Case map_mode of
               MM_SC: if GetMousePos(X,Y) then AddSectorAt(X,Y);
              end;}
  VK_HOME: StraightenTexture(false,false);
 end;

  Renderer.SetGridNormal(n.dx,n.dy,n.dz);
  Renderer.SetGridXNormal(xn.dx,xn.dy,xn.dz);
  Invalidate;
  exit;
 end;

 if shift=[ssShift,ssCtrl] then
 begin
 case key of
  191,VK_HOME: StraightenTexture(true,true);
 end;
 end;

 if shift=[ssCtrl] then
 begin
 case key of
  VK_INSERT: StartStitch;
  191,VK_HOME: StraightenTexture(true,false);
  188: RotateTexture(st_left); {<}
  190: RotateTexture(st_right); {>}
 end;
 exit;
 end;

 case key of
  VK_ESCAPE: CancelMouseMode;
  Ord('1')..Ord('6'):
   With Renderer do
   case Chr(Key) of
    '1': begin PCH:=-90; YAW:=0; ROL:=0; end;
    '2': begin PCH:=0; YAW:=180; ROL:=0; end;
    '3': begin PCH:=0; YAW:=-90; ROL:=0; end;
    '4': begin PCH:=90; YAW:=0; ROL:=0; end;
    '5': begin PCH:=0; YAW:=0; ROL:=0; end;
    '6': begin PCH:=0; YAW:=90; ROL:=0; end;
   end;
  VK_ADD: begin scale:=scale/1.5; Renderer.Scale:=scale;end;
  VK_SUBTRACT: begin scale:=scale*1.5; Renderer.Scale:=scale;end;
  VK_UP,VK_DOWN,VK_LEFT,VK_RIGHT,VK_NEXT,VK_PRIOR:
  With Renderer do
  begin
   ny.dx:=0; ny.dy:=scale; ny.dz:=0;
   RotateVector(ny,PCH,YAW,ROL);
   nx.dx:=scale; nx.dy:=0; nx.dz:=0;
   RotateVector(nx,PCH,YAW,ROL);
   nz.dx:=0; nz.dy:=0; nz.dz:=scale;
   RotateVector(nz,PCH,YAW,ROL);

  case key of
   VK_Down : begin CamX:=CamX+nz.dx; CamY:=CamY+nz.dy; CamZ:=CamZ+nz.dz; end;
   VK_Up: begin CamX:=CamX-nz.dx; CamY:=CamY-nz.dy; CamZ:=CamZ-nz.dz; end;
   VK_LEFT: begin CamX:=CamX+nx.dx; CamY:=CamY+nx.dy; CamZ:=CamZ+nx.dz; end;
   VK_RIGHT: begin CamX:=CamX-nx.dx; CamY:=CamY-nx.dy; CamZ:=CamZ-nx.dz; end;
   VK_PRIOR: begin CamX:=CamX+ny.dx; CamY:=CamY+ny.dy; CamZ:=CamZ+ny.dz; end;
   VK_NEXT: begin CamX:=CamX-ny.dx; CamY:=CamY-ny.dy; CamZ:=CamZ-ny.dz; end;
  end;
  end;
  VK_HOME: With Renderer do begin PCH:=-90; ROL:=0; end;
  VK_RETURN: ItemEdit.Show;
  Ord('A'): Case map_mode of
              MM_SF:
               begin
                surf:=Level.Sectors[Cur_SC].Surfaces[Cur_SF];
                if MakeAdjoin(surf) then
                 begin
                  SectorChanged(surf.sector);
                  SectorChanged(surf.adjoin.sector);
                  SetCurSF(Cur_SC,Cur_SF);
                  PanMessage(mt_info,'1 adjoin formed');
                 end;
                end;
              MM_TH: LayerThing(Cur_TH);
             end;

  VK_MULTIPLY: SetViewToGrid;
  Ord('E'): SetMapMode(MM_ED);
  Ord('X'): if map_mode=MM_SF then
            begin
             surf:=Level.Sectors[cur_sc].Surfaces[cur_sf];
             ExtrudeSurface(surf,surf.ExtrudeSize);
             SetCurSF(Cur_SC,Cur_SF);
            end; 
  Ord('S'): SetMapMode(MM_SC);
  Ord('C'): SetMouseMode(MM_CLEAVE);
  Ord('F'): SetMapMode(MM_SF);
  Ord('K'): SetMouseMode(MM_CreateSector);
  Ord('G'): if GetMousePos(X,Y) then begin SetMouseMode(MM_TranslateGrid); Do_StartTranslateGrid(X,Y); end;
  VK_Space: if GetMousePos(X,Y) then begin SetMouseMode(MM_TranslateCam); Do_StartTranslateCam(X,Y); end;
  Ord('R'): if GetMousePos(X,Y) then begin SetMouseMode(MM_RotateCam); Do_StartRotateCam(X,Y); end;
  Ord('T'): SetMapMode(MM_TH);
  Ord('V'): SetMapMode(MM_VX);
  Ord('L'): SetMapMode(MM_LT);
  Ord('N'): NextObject;
  Ord('P'): PreviousObject;
     VK_F5: With Renderer do Preview3D.SetCam(CamX,CamY,CamZ,0,YAW);
  Ord('M'): begin
            case Map_mode of
             MM_SF: begin
                      surf:=Level.Sectors[Cur_SC].Surfaces[Cur_SF];
                      if surf.adjoin=nil then exit;
                      if MergeSectors(surf) then
                      begin
                       {updated in the procedure}
                       {SectorsChanged(sec);
                       SectorDeleted(sec1);}
                      end;
                    end;  
             MM_ED: begin
                      surf:=Level.Sectors[Cur_SC].Surfaces[Cur_SF];
                      if MergeSurfaces(surf,Cur_ED) then
                      begin
                       {Update in the procedure}
                       {SectorCHanged(surf.sector);}
                      end;
                    end;  
            end;
            SetMapMode(map_mode);
            end;
  VK_INSERT: Begin
              Case map_mode of
               MM_SC: if GetMousePos(X,Y) then CopySectorAt(X,Y);
               MM_LT: if GetMousePos(X,Y) then AddLightAt(X,Y);
               MM_TH: if GetMousePos(X,Y) then AddThingAt(X,Y);
              end;
             end;
  VK_DELETE: begin
             case Map_mode of
              MM_SC: if Level.Sectors.Count>1 then
              begin
               DeleteSector(Level,Cur_SC); {updated in procedure}
              end;
              MM_TH: if Level.Things.Count>1 then
                     begin
                      Free3DO(Level.Things[Cur_TH].a3DO);
                      DeleteThing(Level,Cur_TH);
                     end;
              MM_LT: DeleteLight(Level,Cur_LT);
              MM_VX: DeleteVertex(Level.Sectors[Cur_SC],Cur_VX);
             end;
              SetmapMode(map_mode);
             end;
  {;}  186: StartStitch;
  {'}  222: DoStitch;
  {/}  191: StraightenTexture(false,false);
  {<}  188: JedMain.ShiftTexture(st_left);
  {>}  190: JedMain.ShiftTexture(st_right);
  {[}  219: RaiseObject(ro_up);
  {]}  221: RaiseObject(ro_down);

  else exit;
 end;
 Key:=0;
 Invalidate;
end;

{Mouse operations}

Procedure TJedMain.Do_SelectAt(x,Y:integer);
Var s,sf,ed,th,vx:integer;
    v1,v2:TJKVertex;
    sec:TJKSector;
    Thing:TJKThing;
    light:TJedLight;
begin
 if (LastSelXY.X=X) and (LastSelXY.X=X) and (Renderer.Selected.Count<>0) then
 begin
  if cSel>=Renderer.Selected.Count-1 then csel:=0 else inc(csel);
 end
 else csel:=-1;
if csel=-1 then
begin
 Renderer.BeginPick(X,Y);
 Renderer.SetPointSize(4);
 Case Map_mode of
 MM_SC: for s:=0 to Level.Sectors.Count-1 do
        begin
         Sec:=level.Sectors[s];
         if Toolbar.IsLayerVisible(sec.layer) then
         Renderer.PickPolygons(sec.surfaces,s);
        end;
 MM_SF: for s:=0 to Level.Sectors.Count-1 do
        begin
         sec:=level.Sectors[s];
         if Toolbar.IsLayerVisible(sec.Layer) then
         for sf:=0 to Sec.Surfaces.Count-1 do
          Renderer.PickPolygon(sec.surfaces[sf],s+sf*65536);
        end;
 MM_ED: for s:=0 to Level.Sectors.Count-1 do
        begin
         sec:=level.Sectors[s];
         if Toolbar.IsLayerVisible(sec.Layer) then
         for sf:=0 to Sec.Surfaces.Count-1 do
          With Sec.Surfaces[sf] do
          for ed:=0 to Vertices.Count-1 do
          begin
           v1:=Vertices[ED];
           v2:=Vertices[NextVx(ED)];
           Renderer.PickLine(v1,v2,s*65536+ed*1024+sf);
          end;
        end;
 MM_TH: For th:=0 to Level.Things.Count-1 do
        begin
         thing:=Level.Things[th];
         if Toolbar.ISLayerVisible(thing.Layer) then
         With Thing do Renderer.PickVertex(x,y,z,th);
        end;
 MM_VX: for s:=0 to Level.Sectors.Count-1 do
        begin
         sec:=level.Sectors[s];
         if Toolbar.IsLayerVisible(Sec.Layer) then
         With Sec do
         for vx:=0 to Vertices.Count-1 do
         With Vertices[vx] do
          Renderer.PickVertex(x,y,z,s+vx*65536);
        end;
 MM_LT: for th:=0 to Level.Lights.Count-1 do
        begin
         Light:=Level.Lights[th];
         If Toolbar.IsLayerVisible(Light.Layer) then
         With Light do
          Renderer.PickVertex(x,y,z,th);
        end;
end;
 Renderer.EndPick;
 if Renderer.Selected.Count<>0 then
  csel:=0;
end;
 {Lb.Caption:=IntToStr(Renderer.Selected.Count);}
 if (Renderer.Selected.Count<>0) then
 begin
  case map_mode of
  MM_SC: SetCurSC(Renderer.Selected[csel]);
  MM_SF: begin
          Cur_SC:=Renderer.Selected[csel] mod 65536;
          Cur_SF:=Renderer.Selected[csel] div 65536;
          SetCurSF(Cur_SC,Cur_SF);
         end;
  MM_ED: begin
          vx:=Renderer.Selected[csel];
          s:=vx div 65536;
          sf:=vx mod 1024;
          ed:=(vx mod 65536) div 1024;
          SetCurED(s,sf,ed);
         end;
  MM_TH: SetCurTH(Renderer.Selected[csel]);
  MM_VX: begin
          Cur_SC:=Renderer.Selected[csel] mod 65536;
          Cur_VX:=Renderer.Selected[csel] div 65536;
          SetCurVX(Cur_SC,Cur_VX);
         end;
  MM_LT: SetCurLT(Renderer.Selected[csel]);
 end;
  Invalidate;
 end;

 LastSelXY.X:=X;
 LastSelXY.Y:=Y;

end;

{Cleave mouse functions}

Procedure TJedMain.Do_StartCleave(X,Y:integer;snaptovertex:boolean);
begin
 if CleaveStarted then Redraw;
 With CleaveOrgXY do if not GetMousePos(Integer(X),Integer(Y)) then exit;
 WIth CleaveOrg do
 begin
  if not Renderer.GetGridAt(CleaveOrgXY.X,CleaveOrgXY.Y,X,Y,Z) then exit;
  if snaptoVertex then GetNearestVX(Level,x,y,z,x,y,z,0.2)
  else if SnapToGrid then Renderer.GetNearestGrid(x,y,z,x,y,z);
 end;
 With CleaveOrg do
  Renderer.ProjectPoint(x,y,z,Integer(CleaveOrgXY.X),Integer(CleaveOrgXY.Y));
 LastX:=CleaveOrgXY.X;
 LastY:=CleaveOrgXY.Y;
 SetMouseMode(MM_CLeave);
 CleaveStarted:=true;
end;

Procedure TJedMain.Do_ProceedCleave(X,Y:integer;snaptovertex:boolean);
var fx,fy,fz:double;
begin
 if not CleaveStarted then exit;
 Canvas.Pen.Mode:=pmXor;
 Canvas.Pen.Color:=clRed;
 Canvas.MoveTo(CleaveOrgXY.X,CleaveOrgXY.Y);
 Canvas.LineTo(LastX,LastY);
 Canvas.MoveTo(CleaveOrgXY.X,CleaveOrgXY.Y);

 if not Renderer.GetGridAt(X,Y,fX,fY,fZ) then exit;
 if snaptoVertex then GetNearestVX(Level,fx,fy,fz,fx,fy,fz,0.2)
 else if SnapToGrid then Renderer.GetNearestGrid(fx,fy,fz,fx,fy,fz);

 Renderer.ProjectPoint(fx,fy,fz,X,Y);
 Canvas.LineTo(X,Y);
 LastX:=X; LastY:=Y;
end;

Procedure TJedMain.Do_EndCleave(X,Y:integer;snaptovertex:boolean);
var
    x1,y1,z1,x2,y2,z2:double;
    cnormal:TVector;
    cleaved:boolean;
begin
try
 if not CleaveStarted then exit;

 if not Renderer.GetGridAt(X,Y,X2,Y2,Z2) then exit;
 if snaptoVertex then GetNearestVX(Level,x2,y2,z2,x2,y2,z2,0.2)
 else if SnapToGrid then Renderer.GetNearestGrid(x2,y2,z2,x2,y2,z2);

 With CleaveOrg do begin X1:=X; Y1:=Y; Z1:=Z; end;
 If IsClose(x2,x1) and IsClose(y2,y1) and IsClose(z2,z1) Then exit;
 With Renderer do
 VMult(Gnormal.dx,Gnormal.dy,Gnormal.dz,X2-X1,Y2-Y1,Z2-Z1,cnormal.dX,cNormal.dY,cNormal.dZ);
 Normalize(cnormal);
 cleaved:=false;
 case Map_mode of
  MM_SC:  Cleaved:=CleaveSector(Level.Sectors[Cur_SC],cnormal,x1,y1,z1); {updated in procedure}
  MM_SF:  Cleaved:=CleaveSurface(Level.Sectors[Cur_SC].Surfaces[Cur_SF],
                 cnormal,x1,y1,z1);
  MM_ED: CLeaved:=CleaveEdge(Level.Sectors[Cur_SC].Surfaces[Cur_SF],
                   Cur_ED,cnormal,x1,y1,z1);
 end;
finally
 SetMouseMode(MM_SELECT);
 Invalidate;
 CleaveStarted:=false;
end;
end;

{Mouse Drag functions}

Procedure TJedMain.Do_StartDrag(X,Y:integer);
var fx,fy,fz:double;
begin
 if not Renderer.GetGridAt(X,Y,fx,fy,fz) then exit;
  SetMouseMode(MM_DRAG);
  DragOrg.x:=fx;
  DragOrg.y:=fy;
  DragOrg.z:=fz;
end;

Procedure TJedMain.Do_ProceedDrag(X,Y:integer;snaptovx:boolean);
const
     dragcloseenough=0.2;
var fx,fy,fz,
    dx,dy,dz:double;

Procedure GetDXYZ(rx,ry,rz:double;var dx,dy,dz:double);
var ax,ay,az,d:double;
    arx,ary,arz:double;
begin
 With DragOrg do begin dx:=fx-x; dy:=fy-y; dz:=fz-z; end;
 case snaptovx of
  false: case SnapToGrid of
          false: exit;
          true: begin
                 {Find distance to plane - signed}
                 With renderer do
                 begin
                  {a:=SMult(gnormal.dX,gnormal.dy,gnormal.dz,rx+dx-gridX,ry+dy-GridY,rz+dz-GridZ);}
                  d:=gnormal.dx*GridX+gnormal.dy*GridY+gnormal.dz*GridZ;
                  PlaneLineXn(gnormal,D,rx+dx,ry+dy,rz+dz,rx+dx+gnormal.dx,ry+dy+gnormal.dy,rz+dz+gnormal.dz,
                    arx,ary,arz);
                  Renderer.GetNearestGrid(arx,ary,arz,ax,ay,az);
                  dx:=ax-arx+dx; dy:=ay-ary+dy; dz:=az-arz+dz;
                end;
                end;
         end;
  true: begin
         if not GetNearestVX(Level,rx+dx,ry+dy,rz+dz,ax,ay,az,dragcloseenough) then exit;
         dx:=ax-rx; dy:=ay-ry; dz:=az-rz;
        end;
 end;
end;

Var
    sec:TJKSector;
    surf:TJKSurface;
    vx:TJKVertex;
    th:TJKThing;
    lt:TJedLight;
    i:integer;

begin
 if not Renderer.GetGridAt(X,Y,fx,fy,fz) then exit;
 case map_mode of
  MM_SC: begin
          sec:=Level.Sectors[Cur_SC];
          With Sec.Vertices[0] do GetDXYZ(x,y,z,dx,dy,dz);
          TranslateSector(sec,dx,dy,dz);
         end;
  MM_SF: begin
          Surf:=Level.Sectors[Cur_SC].Surfaces[Cur_SF];
          With Surf.Vertices[0] do GetDXYZ(x,y,z,dx,dy,dz);
          TranslateSurface(surf,dx,dy,dz);
         end;
  MM_VX: begin
          vx:=Level.Sectors[Cur_SC].Vertices[Cur_VX];
          With vx do GetDXYZ(x,y,z,dx,dy,dz);
          TranslateVertex(vx,dx,dy,dz);
         end;
  MM_ED: With Level.Sectors[Cur_SC].Surfaces[Cur_SF] do
         begin
          vx:=Vertices[Cur_ED];
          With vx do GetDXYZ(x,y,z,dx,dy,dz);
          TranslateVertex(vx,dx,dy,dz);
          TranslateVertex(Vertices[NextVx(Cur_ED)],dx,dy,dz);
         end;
  MM_TH: begin
          th:=Level.Things[Cur_TH];
          With th do GetDXYZ(x,y,z,dx,dy,dz);
          TranslateThing(th,dx,dy,dz);
         end; 
  MM_LT: begin
          lt:=Level.Lights[Cur_LT];
          With lt do GetDXYZ(x,y,z,dx,dy,dz);
          TranslateLight(lt,dx,dy,dz);
         end;
 end;
  With DragOrg do
  begin
   x:=x+dx;
   y:=y+dy;
   z:=z+dz;
  end;

 Invalidate;
end;

Procedure TJedMain.Do_EndDrag(X,Y:Integer);
begin
 Case Map_Mode of
  mm_th: LayerThing(Cur_TH);
 end;
 SetMouseMode(MM_SELECT);
end;


Procedure TJedMain.Do_StartTranslateCam(X,Y:integer);
begin
 CamOrg.X:=X;
 CamOrg.Y:=Y;
end;

Procedure TJedMain.Do_TranslateCam(X,Y:integer);
var
 nx,ny,nz:double;
 pnorm:Tvector;
begin
{ With Renderer do
 begin
  SetVec(pnorm,0,1,0);
  RotateVector(pnorm,pch,yaw,rol);
  if not GetXYZonPlaneAt(X,Y,pnorm,CamX,CamY,CamZ,nx,ny,nz) then exit;

  CamX:=nx;
  CamY:=nY;
  CamZ:=nZ;
 end;}

{   ny.dx:=0; ny.dy:=scale*dy; ny.dz:=0;
   RotateVector(ny,PCH,YAW,ROL);
   nx.dx:=scale*dx; nx.dy:=0; nx.dz:=0;
   RotateVector(nx,PCH,YAW,ROL);
   nz.dx:=0; nz.dy:=0; nz.dz:=scale*dx;
   RotateVector(nz,PCH,YAW,ROL);
   With Renderer do
   begin CamX:=CamX+nz.dx; CamY:=CamY+nz.dy; CamZ:=CamZ+nz.dz; end;}

{  Do_StartTranslateCam(X,Y);
  Invalidate;}
end;

Procedure TJedMain.Do_StartRotateCam(X,Y:integer);
begin
 GOrgXY.X:=X; GOrgXY.Y:=Y;
 With GOrg,Renderer do
 begin
  X:=PCH;
  Y:=YAW;
  Z:=ROL;
 end;
end;

Procedure TJedMain.Do_RotateCam(X,Y:integer);
var dx,dy:integer;
begin
 dx:=x-GOrgXY.X;
 dy:=y-GOrgXY.y;
 with GOrg,Renderer do
 begin
  PCH:=X+dY*2;
  YAW:=Y+dX*2;
 end;
 Invalidate;
end;

Procedure TJedMain.Do_StartTranslateGrid(X,Y:integer);
begin
 GOrgXY.X:=X; GOrgXY.Y:=Y;
 With GOrg,Renderer do
 begin
  X:=GridX;
  Y:=GridY;
  Z:=GridZ;
 end;
end;

Procedure TJedMain.Do_TranslateGrid(X,Y:integer);
var pnorm:TVector;
    nx,nY,nZ:double;
begin
{ pnorm.dx:=Cos(Renderer.PCH/180);
 pnorm.dy:=Cos(Renderer.YAW/180);
 pnorm.dz:=Cos(Renderer.ROL/180);}
 With Renderer do
 With Renderer do
 begin
  SetVec(pnorm,0,1,0);
  RotateVector(pnorm,pch,yaw,rol);
  if not GetXYZonPlaneAt(X,Y,pnorm,CamX,CamY,CamZ,nx,ny,nz) then exit;
  GridX:=nx;
  GridY:=ny;
  GridZ:=nz;
  Invalidate;
 end;
end;

Procedure TJedMain.Do_StartRotateGrid(X,Y:integer);
begin
 GOrgXY.X:=X; GOrgXY.Y:=Y;
 With GOrg,Renderer do
 begin
  X:=GridX;
  Y:=GridY;
  Z:=GridZ;
 end;
end;

Procedure TJedMain.Do_RotateGrid(X,Y:integer);
var dx,dy:double;
begin
 dx:=X-GOrgXY.X;
 dy:=Y-GOrgXY.Y;

end;

Procedure TJedMain.DO_StartCreateSC(X,Y:integer;snaptovertex:boolean);
begin
 if SCCreateStarted then Redraw;
 With CleaveOrgXY do if not GetMousePos(Integer(X),Integer(Y)) then exit;
 WIth CleaveOrg do
 begin
  if not Renderer.GetGridAt(CleaveOrgXY.X,CleaveOrgXY.Y,X,Y,Z) then exit;
  if snaptoVertex then GetNearestVX(Level,x,y,z,x,y,z,0.2)
  else if SnapToGrid then Renderer.GetNearestGrid(x,y,z,x,y,z);
 end;
 With CleaveOrg do
  Renderer.ProjectPoint(x,y,z,Integer(CleaveOrgXY.X),Integer(CleaveOrgXY.Y));
 LastX:=CleaveOrgXY.X;
 LastY:=CleaveOrgXY.Y;
 SetMouseMode(MM_CreateSector);
 SCCreateStarted:=true;
end;

Procedure TJedMain.DO_ProceedCreateSC(X,Y:integer;snaptovertex:boolean);
var fx,fy,fz:double;
begin
 if not SCCreateStarted then exit;
 Canvas.Pen.Mode:=pmXor;
 Canvas.Pen.Color:=clRed;
 Canvas.MoveTo(CleaveOrgXY.X,CleaveOrgXY.Y);
 Canvas.LineTo(LastX,LastY);
 Canvas.MoveTo(CleaveOrgXY.X,CleaveOrgXY.Y);

 if not Renderer.GetGridAt(X,Y,fX,fY,fZ) then exit;
 if snaptoVertex then GetNearestVX(Level,fx,fy,fz,fx,fy,fz,0.2)
 else if SnapToGrid then Renderer.GetNearestGrid(fx,fy,fz,fx,fy,fz);

 Renderer.ProjectPoint(fx,fy,fz,X,Y);
 Canvas.LineTo(X,Y);
 LastX:=X; LastY:=Y;
end;

Procedure TJedMain.DO_EndCreateSC(X,Y:integer;snaptovertex:boolean);
var
    x1,y1,z1,x2,y2,z2:double;
    nx,ny,nz:TVector;
    vl:double;
    sc,nsc:TJKSector;
    box:TBox;

begin
try
 if not SCCreateStarted then exit;

 if not Renderer.GetGridAt(X,Y,X2,Y2,Z2) then exit;
 if snaptoVertex then GetNearestVX(Level,x2,y2,z2,x2,y2,z2,0.2)
 else if SnapToGrid then Renderer.GetNearestGrid(x2,y2,z2,x2,y2,z2);

 With CleaveOrg do begin X1:=X; Y1:=Y; Z1:=Z; end;
 nx.dx:=x2-x1; nx.dy:=y2-y1; nx.dz:=z2-z1;

 vl:=Vlen(nx);
 sc:=ToolBar.GetNewShape;

 if vl<0.1 then nx:=Renderer.gxnormal
 else
 begin
  FindBBox(sc,box);
  vl:=box.x2-box.x1;
  SetVec(nx,nx.dx/vl,nx.dy/vl,nx.dz/vl);
 end;

 vl:=Vlen(nx);

 nz:=Renderer.gnormal;
 SetVec(nz,nz.dx*vl,nz.dy*vl,nz.dz*vl);

 VMult(nz.dx,nz.dy,nz.dz,nx.dx,nx.dy,nx.dz,ny.dX,ny.dY,ny.dZ);

 Normalize(ny);
 SetVec(ny,ny.dx*vl,ny.dy*vl,ny.dz*vl);

 nsc:=Level.NewSector;
 DuplicateSector(sc,nsc,nx,ny,nz,x1,y1,z1);
 Level.Sectors.Add(nsc);
 Level.RenumSecs;
 SectorAdded(nsc);
 SetCurSC(level.sectors.count-1);

finally
 SetMouseMode(MM_SELECT);
 Invalidate;
 SCCreateStarted:=false;
end;
end;


procedure TJedMain.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
    t:TJKThing;
begin
case Mouse_mode of
 MM_SELECT:;
 MM_Cleave: DO_StartCleave(X,Y,ssShift in Shift);
 MM_CreateSector: DO_StartCreateSC(X,Y,ssShift in Shift);
end;
end;

procedure TJedMain.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 Case Mouse_mode of
  MM_SELECT: Do_SelectAt(X,Y);
  MM_CreateSector: DO_EndCreateSC(X,Y,ssShift in Shift);
  MM_DRAG: DO_EndDrag(X,Y);
  MM_Cleave: DO_EndCleave(X,Y,ssShift in Shift);
 end;
end;

procedure TJedMain.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var msX,msY:integer;
    gX,gY,gZ:double;
begin
 Case Mouse_Mode of
  MM_SELECT: if (ssLeft in shift) and (ssCtrl in shift) then
              DO_StartDrag(X,Y);
  MM_DRAG: Do_ProceedDrag(X,Y,ssShift in shift);
  MM_Cleave: Do_ProceedCleave(X,Y,ssShift in Shift);
  MM_CreateSector: DO_ProceedCreateSC(X,Y,ssShift in Shift);
  MM_TranslateGrid: Do_TranslateGrid(X,Y);
  MM_TranslateCam: Do_TranslateCam(X,Y);
  MM_RotateCam: Do_RotateCam(X,Y);
 end;

  if GetMousePos(MsX,MsY) and Renderer.GetGridAt(MsX,MsY,GX,gY,gZ) then
  PXYZ.Caption:=Format('X,Y,Z: %2.4f, %2.4f, %2.4f',[gX,gY,gZ]);

end;


procedure TJedMain.Import1Click(Sender: TObject);
var th:TJKThing;
    I,nsec:integer;
    scale:double;
    s:string;
begin
 With GetFileOpen do
 begin
  Filter:='DF files(*.LEV;*.GOB)|*.LEV;*.GOB';
 If Execute then
 begin
  scale:=40;
  s:='40';
  if DFImport.ShowModal<>mrOK then exit;

  scale:=DFImport.VScale.AsFloat;

  MsgForm.msgs.Clear;
  PMsg.Caption:='';
  Level.ImportLev(FileName,scale,DFImport.RGTX.ItemIndex);
  LevelFile:='Untitled.jed';
  newLevel:=true;
  ResetEditor;
  for i:=0 to Level.Things.count-1 do
  begin
   th:=Level.Things[i];
   th.z:=th.z-th.bbox.z1;
   nsec:=FindSectorForThing(th);
   if nsec<>-1 then
    th.Sec:=Level.Sectors[nsec];
   if th.sec=nil then th.layer:=Level.AddLayer('Orphan things')
   else
   begin
    s:=Level.GetLayerName(th.sec.layer);
    s:='Things'+Copy(s,6,length(s));
    th.layer:=Level.AddLayer(s);
   end;
  end;
 end;
 ToolBar.LoadLayers;
end;
end;

procedure TJedMain.FormPaint(Sender: TObject);
begin
 VerifySelection;
 Redraw;
end;

Procedure TJedMain.SetMapMode(mm:integer);
begin
 map_mode:=mm;
 Case mm  of
  MM_SC: SetCurSC(Cur_SC);
  MM_SF: SetCurSF(Cur_SC,Cur_SF);
  MM_VX: SetCurVX(Cur_SC,Cur_VX);
  MM_TH: SetCurTH(Cur_TH);
  MM_ED: SetCurED(Cur_SC,Cur_SF,Cur_ED);
  MM_LT: SetCurLT(Cur_LT);
  else begin ItemEdit.Hide; exit; end;
 end;
 BNSC.Down:=mm=MM_SC;
 BNSF.Down:=mm=MM_SF;
 BNVX.Down:=mm=MM_VX;
 BNED.Down:=mm=MM_ED;
 BNTH.Down:=mm=MM_TH;
 BNLT.Down:=mm=MM_LT;
 Invalidate;
end;

Procedure TJedMain.SetCurSC(SC:integer);
begin
 Cur_SC:=SC;
 if Cur_SC>=Level.Sectors.Count then Cur_SC:=0;
 if Cur_SC<0 then Cur_SC:=Level.Sectors.Count-1;
 EditObject;
end;

Procedure TJedMain.SetCurSF(SC,SF:integer);
begin
 Cur_SC:=SC;
 Cur_SF:=SF;
 if SC>=Level.Sectors.Count then Cur_SC:=0;
 if Cur_SC<0 then Cur_SC:=Level.Sectors.Count-1;

 With Level.Sectors[CUR_SC] do
 begin
  if Cur_SF<0 then Cur_SF:=Surfaces.Count-1;
  if Cur_SF>=Surfaces.Count then Cur_SF:=0;
 end;
 EditObject;
end;

Procedure TJedMain.SetCurVX(SC,VX:integer);
begin
 Cur_SC:=SC; Cur_VX:=VX;
 if SC>=Level.Sectors.Count then Cur_SC:=0;
 if SC<0 then Cur_SC:=Level.Sectors.Count-1;

 With Level.Sectors[CUR_SC] do
 begin
  if VX<0 then Cur_VX:=Vertices.Count-1;
  if VX>=Vertices.Count then Cur_VX:=0;
 end;
 EditObject;
end;

Procedure TJedMain.SetCurED(SC,SF,ED:integer);
begin
 Cur_SC:=SC; Cur_SF:=SF; Cur_ED:=ED;
 if SC>=Level.Sectors.Count then Cur_SC:=0;
 if SC<0 then Cur_SC:=Level.Sectors.Count-1;

 With Level.Sectors[CUR_SC] do
 begin
  if SF<0 then Cur_SF:=Surfaces.Count-1;
  if SF>=Surfaces.Count then Cur_SF:=0;
 end;

 With Level.Sectors[Cur_SC].Surfaces[CUR_SF] do
 begin
  if Vertices.Count=0 then exit;
  if ED=-2 then Cur_ED:=Vertices.Count-1
  else if ED<0 then SetCurED(Cur_SC,Cur_SF-1,-2);
  if ED>=Vertices.Count then SetCurED(Cur_SC,Cur_SF+1,0);;
 end;

 EditObject;
end;


Procedure TJedMain.SetCurTH(TH:integer);
begin
 Cur_TH:=TH;
 if TH>=Level.Things.Count then Cur_TH:=0;
 if TH<0 then Cur_TH:=Level.Things.Count-1;
 EditObject;
end;

Procedure TJedMain.SetCurLT(LT:integer);
begin
 Cur_LT:=LT;
 if LT>=Level.Lights.Count then Cur_LT:=0;
 if LT<0 then Cur_LT:=Level.Lights.Count-1;
 EditObject;
end;

procedure TJedMain.Export1Click(Sender: TObject);
begin
 SaveJKL.FileName:=ChangeFileExt(ExtractName(LevelFile),'.jkl');
 if not SaveJKL.Execute then exit;
 Level.SaveToJKL(SaveJKL.FileName);
end;

procedure TJedMain.SaveJKL1Click(Sender: TObject);
begin
 if IsInContainer(LevelFile) then
 begin
  PanMessage(mt_error,'File is in container - try "SaveJKL to"');
  exit;
 end;
 if NewLevel then
 begin
  PanMessage(mt_error,'Project was never saved');
  exit;
 end;

 Level.SaveToJKL(ChangeFileExt(LevelFile,'.jkl'));
end;

Procedure TJedMain.ResetEditor;
var i:integer;
begin
 With Renderer do
 begin
  CamX:=0;
  CamY:=0;
  CamZ:=0;
  PCH:=-90;
  YAW:=0;
  ROL:=0;
  GridX:=0;
  GridY:=0;
  GridZ:=0;
  SetGridNormal(0,0,1);
  SetGridXNormal(1,0,0);

 end;
 Cur_SC:=0;
 Cur_SF:=0;
 Cur_TH:=0;
 Cur_VX:=0;
 Cur_LT:=0;
 SetMapMode(MM_SC);
 Toolbar.CBGridStep.Text:='0.2';
 Toolbar.CBGrid.Checked:=true;
 Toolbar.LoadLayers;
 {Toolbar.CBLayers.Text:='All';}
 SetLevelName;
 CogForm.RefreshList;

 LoadTemplates;

 changed:=false;
 Preview3D.ReloadLevel;
 SyncRecents;
 SetThingView(cv_Boxes);

 SetMotsIndicator;

 For i:=0 to Level.Things.count-1 do
  UpdateThingData(level.Things[i]);
end;

Procedure TJedMain.SetLevelName;
begin
 Caption:=Format('Jed - %s',[LevelFile]);
 if AskSaveAs then ProjectDir:='' else ProjectDir:=ExtractFilePath(LevelFile);
end;

procedure TJedMain.PlaceCogs1Click(Sender: TObject);
begin
 CogForm.Show;
end;

Procedure TJedMain.AddLightAt(X,Y:integer);
var lx,ly,lz:double;
    lt:TJedLight;
begin
 If not GetXYZAt(X,Y,lx,ly,lz) then exit;
 lt:=Level.NewLight;
 if Cur_LT<Level.Lights.Count then Lt.Assign(Level.Lights[Cur_LT]);
 Level.Lights.Add(lt);
 lt.x:=lx; lt.y:=ly; lt.z:=lz;
 {lt.Layer:=CurLayer;}
 SetCurLT(Level.Lights.Count-1);
 Invalidate;
end;

Procedure TJedMain.AddThingAt(x,y:integer);
var tx,ty,tz:double;
    d:double;
    oldth,th:TJKThing;
begin
 If not GetXYZAt(X,Y,tx,ty,tz) then exit;
 th:=Level.NewThing;

 {Copy data from currently selcted thing}
 if (Cur_TH>=0) and (Cur_TH<Level.Things.Count) then
 begin
  oldth:=Level.Things[Cur_TH];
  th.Assign(oldth);
{  tx:=tx-oldth.bbox.x1;
  ty:=ty-oldth.bbox.y1;}
  tz:=tz-oldth.bbox.z1;
  {  With Renderer,oldth do
  begin
   d:=Abs(Smult(gnormal.dx,gnormal.dy,gnormal.dz,x-GridX,y-GridY,z-GridZ));
   tx:=tx+d*gnormal.dx;
   ty:=ty+d*gnormal.dy;
   tz:=tz+d*gnormal.dz;
  end;}
 end;

 Th.num:=Level.Things.Count;
 Level.Things.Add(th);
 th.x:=tx;
 th.y:=ty;
 th.z:=tz;
 LayerThing(Th.Num);
 SetCurTH(Th.Num);
 ThingAdded(th);
 Invalidate;
end;

Procedure TJedMain.AddSectorAt;
var tx,ty,tz:double;
    en:TVector;
begin
 If not GetXYZAt(X,Y,tx,ty,tz) then exit;
 en:=Renderer.gxnormal;
 en.dx:=en.dx*2; en.dy:=en.dy*2; en.dz:=en.dz*2;

 CreateCube(Level,tx,ty,tz,Renderer.gnormal,en);
 SetCurSC(Level.Sectors.Count-1);
 SectorAdded(Level.Sectors[Level.Sectors.Count-1]);
 Invalidate;
end;

Procedure TJedMain.CopySectorAt(X,Y:integer);
var dx,dy,dz:double;
    i,j:integer;
    sec,newsc:TJKSector;
begin
 If not GetXYZAt(X,Y,dx,dy,dz) then exit;
 sec:=Level.Sectors[Cur_SC];
 newsc:=Level.NewSector;

 WIth Sec.Vertices[0] do begin dx:=dx-x; dy:=dy-y; dz:=dz-z; end;

 With Renderer do
 DuplicateSector(sec,newsc,gxnormal,gynormal,gnormal,dx,dy,dz);

 Level.Sectors.Add(newSc);
 Level.RenumSecs;

 SetCurSC(Level.Sectors.Count-1);
 SectorAdded(Level.Sectors[Level.Sectors.Count-1]);
 Invalidate;
end;


procedure TJedMain.CalculateLights1Click(Sender: TObject);
var sms,ems:longint;
    s:string;
begin
 if Level.Lights.Count=0 then
 begin
  PanMessage(mt_error,'No lights in the level!');
  exit;
 end;
 sms:=GetMSecs;
 CalcLighting(Level,false);
 ems:=GetMSecs;
 sms:=SubMSecs(sms,ems);
 PanMessage(mt_info,Format('%d lights processed in %s',[Level.Lights.Count,StrMSecs(sms)]));
 Preview3D.ReloadLevel;
 LevelChanged;
end;

procedure TJedMain.Onvisiblelayers1Click(Sender: TObject);
var sms,ems:longint;
    s:string;
    i:integer;
    sec:TJKSector;
begin
 if Level.Lights.Count=0 then
 begin
  PanMessage(mt_error,'No lights in the level!');
  exit;
 end;
 sms:=GetMSecs;
 CalcLighting(Level,true);
 ems:=GetMSecs;
 sms:=SubMSecs(sms,ems);
 PanMessage(mt_info,Format('%d lights processed in %s',[Level.Lights.Count,StrMSecs(sms)]));

 for i:=0 to Level.Sectors.count-1 do
 begin
  sec:=Level.Sectors[i];
  if ToolBar.IsLayerVisible(sec.layer) then
   SectorChanged(sec);
 end;
end;


procedure TJedMain.ConsistencyCheck1Click(Sender: TObject);
begin
 Consistency.Check;
end;

procedure TJedMain.CheckResources1Click(Sender: TObject);
begin
 Consistency.CheckResources;
end;

procedure TJedMain.About1Click(Sender: TObject);
begin
 Jed_About.ShowModal;
end;

procedure TJedMain.BNSCClick(Sender: TObject);
begin
 if Sender=BNSC then SetMapMode(MM_SC)
 else if Sender=BNSF then SetMapMode(MM_SF)
 else if Sender=BNED then SetMapMode(MM_ED)
 else if Sender=BNVX then SetMapMode(MM_VX)
 else if Sender=BNTH then SetMapMode(MM_TH)
 else if Sender=BNLT then SetMapMode(MM_LT);
end;

Procedure TJedMain.NextObject;
var i,n,fi:integer;
begin
 case Map_mode of
 MM_SC: begin
         fi:=Cur_Sc;
         n:=fi;
         repeat
          if n>=Level.Sectors.Count-1 then n:=0 else inc(n);
          if n=fi then exit;
         until ToolBar.IsLayerVisible(Level.Sectors[n].Layer);

         SetCurSC(n);
        end;
 MM_SF: SetCurSF(Cur_SC,Cur_SF+1);
 MM_VX: SetCurVX(Cur_SC,Cur_VX+1);
 MM_ED: SetCurED(Cur_SC,Cur_SF,Cur_ED+1);
 MM_TH: begin
         fi:=Cur_TH;
         n:=fi;
         repeat
          if n>=Level.Things.Count-1 then n:=0 else inc(n);
          if n=fi then exit;
         until ToolBar.IsLayerVisible(Level.Things[n].Layer);
         SetCurTH(n);
        end;
 MM_LT: begin
         fi:=Cur_LT;
         n:=fi;
         repeat
          if n>=Level.Lights.Count-1 then n:=0 else inc(n);
          if n=fi then exit;
         until ToolBar.IsLayerVisible(Level.Lights[n].Layer);
         SetCurLT(n);
        end;
 end;
 Invalidate;
end;

Procedure TJedMain.PreviousObject;
var i,fi,n:integer;
begin
 case Map_mode of
 MM_SC: begin
         fi:=Cur_Sc;
         n:=fi;
         repeat
          if n<1 then n:=Level.Sectors.Count-1 else dec(n);
          if n=fi then exit;
         until ToolBar.IsLayerVisible(Level.Sectors[n].Layer);
         SetCurSC(n);
        end;
 MM_SF: SetCurSF(Cur_SC,Cur_SF-1);
 MM_VX: SetCurVX(Cur_SC,Cur_VX-1);
 MM_ED: SetCurED(Cur_SC,Cur_SF,Cur_ED-1);
 MM_TH: begin
         fi:=Cur_TH;
         n:=fi;
         repeat
          if n<1 then n:=Level.Things.Count-1 else dec(n);
          if n=fi then exit;
         until ToolBar.IsLayerVisible(Level.Things[n].Layer);
         SetCurTH(n);
        end;
 MM_LT: begin
         fi:=Cur_LT;
         n:=fi;
         repeat
          if n<1 then n:=level.Lights.count-1 else dec(n);
          if n=fi then exit;
         until ToolBar.IsLayerVisible(Level.Lights[n].Layer);
         SetCurLT(n);
        end;
 end;
 Invalidate;
end;

Procedure TJedMain.NextObjectInSurface;
var surf:TJKSurface;
begin
case map_mode of
 MM_ED:  begin
          surf:=Level.Sectors[Cur_SC].Surfaces[Cur_SF];
          if Cur_ED>=surf.vertices.count-1 then SetCurED(Cur_SC,Cur_SF,0)
          else SetCurED(Cur_SC,Cur_SF,Cur_ED+1);
         end;

end;
end;

Procedure TJedMain.PreviousObjectInSurface;
var surf:TJKSurface;
begin
case map_mode of
 MM_ED:  begin
          surf:=Level.Sectors[Cur_SC].Surfaces[Cur_SF];
          if Cur_ED<=0 then SetCurED(Cur_SC,Cur_SF,surf.vertices.count-1)
          else SetCurED(Cur_SC,Cur_SF,Cur_ED-1);
         end;

end;
end;


Function TJedMain.GetXYZAt(atX,atY:integer;var X,Y,Z:double):boolean;
begin
 Result:=false;
 Result:=Renderer.GetGridAt(atx,aty,x,y,z);
 if not result then exit;
 if SnapToGrid then Renderer.GetNearestGrid(x,y,z,x,y,z);
end;


Function TJedMain.GetMousePos(var X,Y:integer):boolean;
var    pt:TPoint;
begin
 result:=false;
 GetCursorPos(Pt);
 pt := ScreenToClient(pt);
 X:=pt.X; Y:=pt.Y;
 if not PtInRect(ClientRect,pt) then exit;
 Result:=true;
end;

Procedure TJedMain.SetMouseMode(mm:integer);
begin
 Case mm of
  MM_SELECT: CurSor:=crDefault;
  MM_Cleave: Cursor:=crSaber;
  MM_Drag: Cursor:=crDrag;
  MM_TranslateCam: Cursor:=crSize;
  MM_RotateCam: Cursor:=crDefault;
  MM_TranslateGrid: Cursor:=crSize;
  MM_RotateGrid: Cursor:=crDefault;
  MM_CreateSector: CurSor:=crDefault;
 else exit;
 end;
 mouse_mode:=mm;
end;

Procedure TJedMain.EditObject;
begin
 if not IsSelValid then exit;
 case Map_mode of
  MM_SC: ItemEdit.LoadSector(Level.Sectors[Cur_SC]);
  MM_SF: ItemEdit.LoadSurface(Level.Sectors[Cur_SC].Surfaces[Cur_SF]);
  MM_VX: ItemEdit.LoadVertex(Level.Sectors[Cur_SC].Vertices[Cur_VX]);
  MM_TH: ItemEdit.LoadThing(Level.Things[Cur_TH]);
  MM_LT: ItemEdit.LoadLight(Cur_LT);
  MM_ED: ItemEdit.LoadEdge(Level.Sectors[Cur_SC].Surfaces[Cur_SF],Cur_ED);
 end;
end;

Procedure TJedMain.GotoSC(sc:integer);
var sec:TJKSector;
begin
{ sec:=Level.Sectors[sc];
 With Sec.Vertices[0],Renderer do
 begin
  camX:=X;
  CamY:=Y;
  CamZ:=Z;
 end; }
 SetCurSC(SC);
 SetMapMode(MM_SC);
end;

Procedure TJedMain.GotoSF(sc,sf:integer);
var surf:TJKSurface;
begin
{ surf:=Level.Sectors[sc].Surfaces[sf];
 With Surf.Vertices[0],Renderer do
 begin
  camX:=X;
  CamY:=Y;
  CamZ:=Z;
 end;}
 SetCurSF(Sc,Sf);
 SetMapMode(MM_SF);
end;

Procedure TJedMain.GotoTH(th:Integer);
var thing:TJKthing;
begin
 thing:=Level.Things[th];
{ With Thing,Renderer do
 begin
  camX:=X;
  CamY:=Y;
  CamZ:=Z;
 end;}
 SetCurTH(TH);
 SetMapMode(MM_TH);
end;



procedure TJedMain.ItemEditor1Click(Sender: TObject);
begin
 ItemEdit.Show;
end;

procedure TJedMain.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 case key of
  Ord('G'): SetMouseMode(MM_SELECT);
  Ord('R'): SetMouseMode(MM_SELECT);
  VK_Space: SetMouseMode(MM_SELECT);
 end;
end;

procedure TJedMain.MUNextObjectClick(Sender: TObject);
begin
 NextObject;
end;

procedure TJedMain.MUPrevObjectClick(Sender: TObject);
begin
 PreviousObject;
end;

Procedure TJedMain.SnapGridToObject;
var rx,ry,rz:double;
    norm:TVector;
    xnorm:TVector;
    v1,v2:TJKVertex;
begin
 norm:=Renderer.gnormal;
 xnorm:=Renderer.gxnormal;
 case map_mode of
  MM_SC: begin
          With Level.Sectors[Cur_SC].Vertices[0] do begin rx:=x; ry:=y; rz:=z; end;
         end;
  MM_SF: With Level.Sectors[Cur_SC].Surfaces[Cur_SF] do
         begin
          v1:=Vertices[0];
          v2:=Vertices[1];
          with v1 do begin rx:=x; ry:=y; rz:=z; end;
          norm:=normal;
          xnorm.dx:=v2.x-v1.x;
          xnorm.dy:=v2.y-v1.y;
          xnorm.dz:=v2.z-v1.z;
         end;
  MM_ED: With Level.Sectors[Cur_SC].Surfaces[Cur_SF] do
         begin
          v1:=Vertices[Cur_ED];
          v2:=Vertices[NextVX(Cur_ED)];
          with v1 do begin rx:=x; ry:=y; rz:=z; end;
          norm:=normal;
          xnorm.dx:=v2.x-v1.x;
          xnorm.dy:=v2.y-v1.y;
          xnorm.dz:=v2.z-v1.z;
         end;
  MM_VX: With Level.Sectors[Cur_SC].Vertices[Cur_VX] do begin rx:=x; ry:=y; rz:=z; end;
  MM_TH: With Level.Things[Cur_TH] do begin rx:=x; ry:=y; rz:=z; end;
  MM_LT: With Level.Lights[Cur_LT] do begin rx:=x; ry:=y; rz:=z; end;
  else exit;
 end;
 With Renderer do
 begin
  GridX:=rx;
  GridY:=ry;
  GridZ:=rz;
  With norm do SetGridNormal(dx,dy,dz);
  With xnorm do SetGridXNormal(dx,dy,dz);
  Invalidate;
 end;
end;

procedure TJedMain.MUSnapGridToClick(Sender: TObject);
begin
 SnapGridToObject;
end;

Procedure TJedMain.LayerThing(n:integer);
var nsec:integer;
    thing:TJKThing;
begin
 thing:=Level.Things[n];
 nsec:=FindSectorForThing(Thing);
 if nsec=-1 then thing.sec:=nil  else thing.Sec:=Level.Sectors[nsec];
 if nsec<>-1 then PanMessage(mt_info,'1 thing layered');
 ThingChanged(thing);
end;

procedure TJedMain.ToolWindow1Click(Sender: TObject);
begin
 ToolForm.Show;
end;

procedure TJedMain.FormShow(Sender: TObject);
begin
 ResetEditor;
end;

procedure TJedMain.Options1Click(Sender: TObject);
begin
 Options.SetOptions(nil);
 Invalidate;
end;

procedure TJedMain.CancelMouseMode;
begin
 case Mouse_mode of
  MM_Cleave: begin Invalidate; cleavestarted:=false; end;
 end;
 SetMouseMode(MM_SELECT);
end;

procedure TJedMain.New1Click(Sender: TObject);
begin
 if Not AskSave then exit;
 MsgForm.msgs.Clear;
 PMsg.Caption:='';
 SetMots(false);
 NewProject;
 ResetEditor;
end;

procedure TJedMain.NewMOTSProject1Click(Sender: TObject);
begin
 if Not AskSave then exit;
 MsgForm.msgs.Clear;
 PMsg.Caption:='';
 SetMots(true);
 NewProject;
 ResetEditor;
end;

procedure TJedMain.FormDestroy(Sender: TObject);
begin
 GetWinPos(Self,MWinPos);
end;

Procedure TJedMain.Goto_Adjoin;
var sf:TJKSurface;
begin
 sf:=Level.Sectors[Cur_SC].Surfaces[Cur_SF];
 if sf.adjoin=nil then exit;

 SetCurSF(sf.Adjoin.Sector.num,sf.Adjoin.num);
 Invalidate;
end;

procedure TJedMain.GobProject1Click(Sender: TObject);
var gobname:string;
    gob:TGOB2Creator;
    flist,ls:TStringList;
    idir,s,ext:string;
    i:integer;
    f:TFile;
    njkls:integer;
begin
 if NewLevel then
 begin
  PanMessage(mt_error,'Project was never saved');
  exit;
 end;
 if IsInContainer(LevelFile) then
 begin
  PanMessage(mt_error,'Level is in container - can''t gob');
  exit;
 end;

 ext:=UpperCase(ExtractFileExt(LevelFile));
 if Ext='.JED' then Idir:=ProjectDir else iDir:=ExtractFilePath(LevelFile);
 gobname:=ExtractFilePath(SaveGob.FileName);
 if gobname='' then gobname:=GameDir;

 if isMots then
 begin
  SaveGob.FileName:=gobname+ChangeFileExt(ExtractFileName(LevelFile),'.goo');
  SaveGob.FilterIndex:=2;
  SaveGob.DefaultExt:='goo';
 end
 else
 begin
  SaveGob.FileName:=gobname+ChangeFileExt(ExtractFileName(LevelFile),'.gob');
  SaveGob.FilterIndex:=1;
  SaveGob.DefaultExt:='gob';
 end;
 
 if not SaveGob.Execute then exit;
 gobname:=SaveGob.FileName;
 gob:=TGOB2Creator.Create(gobname);
 flist:=TStringList.Create;
 ls:=TStringList.Create;
 njkls:=0;
 try
  ListDirMask(idir,'*.*',ls);
  for i:=0 to ls.count-1 do
  begin
    s:=ls[i];
    ext:=UpperCase(ExtractFileExt(s));
   if ext='.JK' then flist.Add(s)
   else if ext='.JKL' then begin flist.Add('jkl\'+s); inc(njkls); end
   else if ext='.COG' then flist.Add('cog\'+s)
   else if ext='.3DO' then flist.Add('3do\'+s)
   else if ext='.MAT' then flist.Add('mat\'+s)
   else if ext='.DAT' then flist.Add('misc\'+s)
   else if ext='.UNI' then flist.Add('misc\'+s)
   else if ext='.KEY' then flist.Add('3do\key\'+s)
   else if ext='.AI' then flist.Add('misc\ai\'+s)
   else if ext='.CMP' then flist.Add('misc\cmp\'+s)
   else if ext='.PAR' then flist.Add('misc\par\'+s)
   else if ext='.PER' then flist.Add('misc\per\'+s)
   else if ext='.PUP' then flist.Add('misc\pup\'+s)
   else if ext='.AI' then flist.Add('misc\ai\'+s)
   else if ext='.SND' then flist.Add('misc\snd\'+s)
   else if ext='.SPR' then flist.Add('misc\spr\'+s)
   else if ext='.WAV' then flist.Add('sound\'+s)
   else if ext='.BM' then flist.Add('ui\bm\'+s)
   else if ext='.SFT' then flist.Add('ui\sft\'+s)
   else if ext='.SMK' then flist.Add('video\'+s)
   else if ext='.SAN' then flist.Add('video\'+s)
   else if ext='.SND' then flist.Add('snd\'+s);
  end;

  if njkls=0 then
  begin
   PanMessage(mt_error,'No JKL files found in project directory. Use "Save JKL" to create one');
   exit;
  end;

  Progress.Reset(flist.count);

  gob.PrepareHeader(flist);
  for i:=0 to flist.count-1 do
  begin
   Progress.Step;
   f:=OpenFileRead(IDir+ExtractFileName(fList[i]),0);
   gob.AddFile(f);
   f.Fclose;
  end;

 finally
  gob.Free;
  ls.free;
  flist.free;
  Progress.hide;
 end;
end;


procedure TJedMain.Viewtogrid1Click(Sender: TObject);
begin
 SetViewToGrid;
end;

procedure TJedMain.GridtoView1Click(Sender: TObject);
begin
 SetGridToView;
end;

Procedure TJedMain.SetGridToView;
var x,z:TVector;
begin
 SetVec(x,1,0,0);
 SetVec(z,0,-1,0);
 With Renderer do RotateVector(x,pch,yaw,rol);
 With Renderer do RotateVector(z,pch,yaw,rol);
 Renderer.SetGridNormal(z.dx,z.dy,z.dz);
 Renderer.SetGridXNormal(x.dx,x.dy,x.dz);
 Invalidate;
end;


Procedure TJedMain.SetViewToGrid;
var xy:double;

Function sign(v:double):double;
begin
 if v<0 then Result:=-1 else result:=1;
end;

begin
With Renderer do
begin
  xy:=sqrt(sqr(gnormal.dx)+sqr(gnormal.dy));
  ROL:=0;
  if xy=0 then begin PCH:=sign(-gnormal.dz)*90; YAW:=0; end
  else
  begin
    YAW:=Sign(gnormal.dx)*ArcCos(-gnormal.dy/xy)/pi*180;
    PCH:=Sign(-gnormal.dz)*ArcCos(xy)/pi*180;
  end;

 CamX:=GridX;
 camY:=GridY;
 CamZ:=GridZ;
 Invalidate;
end;
end;

procedure TJedMain.Toolbar1Click(Sender: TObject);
begin
 Toolbar.Show;
end;

procedure TJedMain.Topics1Click(Sender: TObject);
begin
 Application.HelpFile:=BaseDir+'Jedhelp.hlp';
 Application.HelpContext(10);
end;

procedure TJedMain.JedTutor1Click(Sender: TObject);
begin
 Application.HelpFile:=BaseDir+'Jedtutor.hlp';
 Application.HelpContext(10);
end;

procedure TJedMain.N3DPreview1Click(Sender: TObject);
begin
 Preview3D.ShowPreview;
end;

Procedure TJedMain.ShiftTexture(how:integer);
var du,dv:double;
    surf:TJKSurface;
    i:integer;
begin
 if map_mode<>MM_SF then SetMapMode(MM_SF);
 if not Preview3D.IsActive then exit;
 case how of
  st_left: begin du:=TXStep; dv:=0; end;
  st_right: begin du:=-TXStep; dv:=0; end;
  st_up: begin du:=0; dv:=-TXStep; end;
  st_down: begin du:=0; dv:=TXStep; end;
  else exit;
 end;
 surf:=Level.Sectors[cur_SC].Surfaces[Cur_SF];
 for i:=0 to surf.TXVertices.count-1 do
 With surf.TXVertices[i] do
 begin
  u:=u+du;
  v:=v+dv;
 end;
 SectorChanged(surf.sector);
end;

Procedure TJedMain.RotateTexture(how:integer);
var nu,nv,u,v:tvector;
    surf:TJKSurface;
    du,dv,cosa,sina:double;
    fv:integer;
begin
 if not Preview3D.IsActive then exit;

 fv:=0;
 case map_mode of
  MM_ED: fv:=Cur_ED;
  MM_SF: fv:=0;
  else SetMapMode(MM_SF);
 end;

 case how of
  st_left: begin cosa:=cos(-TXRotStep*pi/180); sina:=sin(-TXRotStep*pi/180); end;
  st_right: begin cosa:=cos(TXRotStep*pi/180); sina:=sin(TXRotStep*pi/180); end;
 end;

 surf:=Level.Sectors[cur_SC].Surfaces[Cur_SF];
 CalcUVNormals(surf,u,v);

  nv.dx:=-sina*u.dx+cosa*v.dx;
  nv.dy:=-sina*u.dy+cosa*v.dy;
  nv.dz:=-sina*u.dz+cosa*v.dz;

  nu.dx:=cosa*u.dx+sina*v.dx;
  nu.dy:=cosa*u.dy+sina*v.dy;
  nu.dz:=cosa*u.dz+sina*v.dz;

  ArrangeTexture(surf,fv,nu,nv);
  SectorChanged(surf.sector);
end;

procedure TJedMain.PMsgDblClick(Sender: TObject);
begin
 PMsg.caption:='';
end;

procedure TJedMain.Messages1Click(Sender: TObject);
begin
 MsgForm.Show;
end;

Procedure TJedMain.SectorChanged(s:TJKSector);
begin
 Preview3D.UpdateSector(s);
 LevelChanged;
end;

Procedure TJedMain.SectorAdded(s:TJKSector);
begin
 Preview3D.AddSector(s);
 LevelChanged;
end;

Procedure TJedMain.SectorDeleted(s:TJKSector);
begin
 Preview3D.DeleteSector(s);
 LevelChanged;
end;

Procedure TJedMain.ThingChanged(th:TJKThing);
begin
 UpdateThingData(th);
 Preview3D.UpdateThing(th);
 LevelChanged;
end;

Procedure TJedMain.ThingAdded(th:TJKThing);
begin
 UpdateThingData(th);
 Preview3D.AddThing(th);
 LevelChanged;
end;

Procedure TJedMain.ThingDeleted(th:TJKThing);
begin
 Preview3D.DeleteThing(th);
 LevelChanged;
end;

Procedure TJedMain.RotateObject(angle:double; axis:integer);
var sec:TJKSector;
    i:integer;
begin
 case map_mode of
  MM_SC: begin
          sec:=Level.Sectors[Cur_SC];
          RotateSector(sec,angle,axis);
          SectorChanged(sec);
          for i:=0 to sec.surfaces.count-1 do
          with sec.surfaces[i] do
          begin
           if adjoin=nil then continue;
           SectorChanged(adjoin.Sector);
          end;
         end;
 end;
Invalidate;
end;

Procedure TJedMain.ScaleObject(sfactor:double);
var sec:TJKSector;
    i:integer;
begin
 case map_mode of
  MM_SC: begin
          sec:=Level.Sectors[Cur_SC];
          ScaleSector(sec,sfactor);
          SectorChanged(sec);
          for i:=0 to sec.surfaces.count-1 do
          with sec.surfaces[i] do
          begin
           if adjoin=nil then continue;
           SectorChanged(adjoin.Sector);
          end;
         end;
 end;
Invalidate;
end;

Procedure TJedMain.TranslateObject(dx,dy,dz:double);
var sec:TJKSector;
    surf:TJKSurface;
    i:integer;
begin
case Map_Mode of
 MM_SC: begin
         sec:=Level.Sectors[Cur_SC];
         TranslateSector(sec,dx,dy,dz);
        end;
 MM_SF: begin
         surf:=Level.Sectors[Cur_SC].Surfaces[Cur_SF];
         TranslateSurface(surf,dx,dy,dz);
        end;
end;
Invalidate;
end;

Procedure TJedMain.StartStitch;
begin
if map_mode<>MM_SF then exit;
 stitch_Sec:=Level.Sectors[Cur_SC];
 stitch_Surf:=Level.Sectors[Cur_SC].Surfaces[Cur_SF];
end;

Procedure TJedMain.DoStitch;
var ssurf,esurf:TJKSurface;
begin
if map_mode<>MM_SF then exit;
if stitch_sec=nil then
begin
 PanMessage(mt_error,'No start surface was set for stitching');
 exit;
end;

if (Level.Sectors.IndexOf(stitch_sec)<0) or
 (stitch_sec.Surfaces.IndexOf(stitch_surf)<0) then
 begin
  PanMessage(mt_error,'The stitching start surface was deleted');
  exit;
 end;
 ssurf:=stitch_surf; esurf:=Level.Sectors[Cur_SC].Surfaces[Cur_SF];
 if ssurf.Material<>'' then esurf.Material:=ssurf.Material;

 StitchSurfaces(ssurf,esurf);

 SectorChanged(esurf.sector);
 StartStitch;
end;

Procedure TJedMain.StraightenTexture(zero,rot90:boolean);
var u,v:tvector;
    surf:TJKSurface;
begin
 if map_mode=MM_ED then
 begin
  surf:=Level.Sectors[Cur_SC].Surfaces[Cur_SF];

  if rot90 then
  begin
   CalcDefaultUVNormals(surf,Cur_ED,v,u);
   v.dx:=-v.dx;
   v.dy:=-v.dy;
   v.dz:=-v.dz;
  end else CalcDefaultUVNormals(surf,Cur_ED,u,v);

  if zero then with surf.TXvertices[Cur_ED] do
  begin
   u:=0;
   v:=0;
  end;
  ArrangeTexture(surf,Cur_ED,u,v);
  SectorChanged(surf.sector);
  exit;
 end;
 if map_mode<>MM_SF then exit;
 surf:=Level.Sectors[Cur_SC].Surfaces[Cur_SF];
 if rot90 then
 begin
  CalcUVNormals(surf,v,u);
  v.dx:=-v.dx;
  v.dy:=-v.dy;
  v.dz:=-v.dz;
 end else CalcUVNormals(surf,u,v);
 if zero then
 With surf.txvertices[0] do begin u:=0; v:=0; end;
 ArrangeTexture(surf,0,u,v);
 SectorChanged(surf.sector);
end;

Procedure TJedMain.SetCam(X,Y,Z,PCH,YAW,ROL:Double);
begin
 Renderer.CamX:=x;
 Renderer.CamY:=Y;
 Renderer.CamZ:=Z;
 Renderer.PCH:=PCH;
 Renderer.YAW:=YAW;
 Renderer.ROL:=ROL;
 Invalidate;
end;

Procedure TJedMain.RaiseObject(how:integer);
var dx,dy,dz:double;
    th:TJKThing;
begin

 With Renderer do
 if how=ro_up then begin dx:=gnormal.dx*perpStep; dy:=gnormal.dy*perpStep; dz:=gnormal.dz*perpStep; end
 else begin dx:=-gnormal.dx*perpStep; dy:=-gnormal.dy*perpStep; dz:=-gnormal.dz*perpStep; end;

 case Map_mode of
  MM_SC: TranslateSector(Level.Sectors[Cur_SC],dx,dy,dz);
    MM_SF: TranslateSurface(Level.Sectors[Cur_SC].Surfaces[Cur_SF],
           dx,dy,dz);
  MM_VX: TranslateVertex(Level.Sectors[Cur_SC].Vertices[Cur_VX],
           dx,dy,dz);
  MM_ED: With Level.Sectors[Cur_SC].Surfaces[Cur_SF] do
         begin
          TranslateVertex(Vertices[Cur_ED],dx,dy,dz);
          TranslateVertex(Vertices[NextVx(Cur_ED)],dx,dy,dz);
         end;
  MM_TH: begin
          th:=Level.Things[cur_th];
          th.x:=th.x+dx; th.y:=th.y+dy; th.z:=th.z+dz;
          LayerThing(Cur_TH);
          ThingChanged(th);
         end;
  MM_LT: With Level.Lights[cur_lt] do begin x:=x+dx; y:=y+dy; z:=z+dz; LevelChanged; end;
  else exit;
 end;
 Invalidate;
end;

Procedure TJedMain.VerifySelection;
begin
 if not IsSelValid then SetMapMode(map_mode);
end;

Function TJedMain.IsSelValid:boolean;
begin
 case map_mode of
  MM_SC: result:=(Cur_SC>=0) and (Cur_SC<Level.Sectors.count);
  MM_SF: begin
          result:=false;
          if (Cur_SC<0) or (Cur_SC>=Level.Sectors.count) then exit;
          Result:=(Cur_SF>=0) and (Cur_SF<Level.Sectors[Cur_SC].Surfaces.count);
         end;
  MM_ED: begin
          result:=false;
          if (Cur_SC<0) or (Cur_SC>=Level.Sectors.count) then exit;
          if (Cur_SF<0) or (Cur_SF>=Level.Sectors[Cur_SC].Surfaces.count) then exit;
          Result:=(Cur_ED>=0) and (Cur_ED<Level.Sectors[Cur_SC].Surfaces[Cur_SF].Vertices.count);
         end;
  MM_VX: begin
          result:=false;
          if (Cur_SC<0) or (Cur_SC>=Level.Sectors.count) then exit;
          Result:=(Cur_VX>=0) and (Cur_VX<Level.Sectors[Cur_SC].Vertices.count);
         end;
  MM_TH: result:=(Cur_TH>=0) and (Cur_TH<Level.Things.count);
  MM_LT: result:=(Cur_LT>=0) and (Cur_LT<Level.Lights.count);
 else result:=false;
 end;
end;

procedure TJedMain.RecentClick(Sender: TObject);
begin
 if Not AskSave then exit;
 OpenProject((Sender as TMenuItem).hint);
end;

Procedure TJedMain.SyncRecents;
var im:integer;

Procedure AddItem(const s:string);
var mi:TMenuItem;
    dn,fn:string;
begin
 if s='' then exit;
 mi:=TMenuItem.Create(FileMenu);
 if length(s)>32 then
 begin
  dn:=ExtractPath(s);
  fn:=ExtractName(s);
  dn:=copy(dn,1,28-length(fn));
  mi.caption:=dn+'...'+'\'+fn;
 end
 else mi.Caption:=s;
 mi.hint:=s;
 mi.OnClick:=RecentClick;
 FileMenu.Add(mi);
end;

begin
 im:=RecentBar.MenuIndex;
 While FileMenu.Count>im+1 do FileMenu.Delete(im+1);
 AddItem(Recent1);
 AddItem(Recent2);
 AddItem(Recent3);
 AddItem(Recent4);
end;

Procedure TJedMain.AddRecent(const s:string);
begin
 if compareText(Recent1,s)=0 then exit;
 if compareText(Recent2,s)=0 then exit;
 if compareText(Recent3,s)=0 then exit;
 if compareText(Recent4,s)=0 then exit;
 Recent4:=Recent3;
 Recent3:=Recent2;
 Recent2:=Recent1;
 Recent1:=s;
 SyncRecents;
end;

procedure TJedMain.SaveJKLGob1Click(Sender: TObject);
begin
 SaveJKL1.Click;
 GobProject1.Click;
end;


procedure TJedMain.Find1Click(Sender: TObject);
begin
 case map_mode of
  MM_SC: FindSectors.Find;
  MM_SF: FindSurfs.Find;
  MM_TH: FindThings.Find;
 end;
end;

procedure TJedMain.FindNext1Click(Sender: TObject);
begin
 case map_mode of
  MM_SC: FindSectors.FindNext(Cur_SC);
  MM_SF: FindSurfs.FindNext(Cur_SC,Cur_SF);
  MM_TH: FindThings.FindNext(cur_TH);
 end;
end;

Procedure TJedMain.LevelChanged;
begin
 changed:=true;
end;

Function TJedMain.AskSave:boolean;
begin
 Result:=true;
 if not changed then exit;
 Case MsgBox('The project was changed. Save?','JED',MB_YESNOCANCEL) of
  ID_YES: Result:=SaveProject;
  ID_NO:;
  ID_CANCEL: result:=false;
 end;
end;

procedure TJedMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 CanClose:=AskSave;
end;

procedure TJedMain.Levelheadereditor1Click(Sender: TObject);
begin
 if not LHEdit.EditHeader then exit;
 Preview3D.ReloadLevel;
 LevelChanged;
end;

Procedure TJedMain.SetThingView(how:integer);
var i:integer;
begin
 thing_view:=how;
 case how of
  cv_Dots: Dots.Checked:=true;
  cv_Boxes: Boxes.Checked:=true;
  cv_WireFrames:
   begin
    WireFrames.Checked:=true;
    Progress.Reset(Level.Things.Count);
    Progress.Msg:='Loading 3DOs...';
    for i:=0 to Level.Things.Count-1 do
    begin
     UpdateThingData(Level.Things[i]);
     Progress.Step;
    end;
    Progress.Hide;
   end;
 end;
 Invalidate;
end;

Procedure LoadThing3DO(th:TJKThing;force:boolean);
var
    tval:TTPLValue;
    itpl:integer;
    tpl:TTemplate;
    a3DO:T3DO;
begin
 if not force and (th.a3Do<>nil) then exit;
 itpl:=Templates.IndexOfName(th.name);
 if itpl=-1 then
 begin
  Free3DO(th.a3do);
  exit;
 end;
 tval:=Templates.GetTPLField(th.name,'model3d');
 if tval=nil then a3Do:=nil else a3Do:=Load3DO(tval.AsString);
 Free3DO(th.a3DO);
 th.a3DO:=a3DO;
 if a3DO<>nil then a3DO.GetBBOX(th.bbox);
end;

Procedure TJedMain.UpdateThingData(th:TJKThing);
var
    itpl:integer;
    tpl:TTemplate;
begin
 case thing_view of
 cv_dots,cv_boxes:
  begin
   itpl:=Templates.IndexOfName(th.name);
   if itpl=-1 then FillChar(th.Bbox,sizeof(th.Bbox),0) else
   begin
    {Assign BBOX}
    th.bbox:=Templates[itpl].Bbox;
   end;
   if Preview3D.IsActive and P3DThings then LoadThing3DO(th,true);
  end;
 cv_wireframes: LoadThing3DO(th,true);
 end;
end;

procedure TJedMain.WireframesClick(Sender: TObject);
begin
 if Sender=Dots then SetThingView(cv_Dots)
 else if Sender=Boxes then SetThingView(cv_Boxes)
 else if Sender=Wireframes then SetThingView(cv_Wireframes);
end;

procedure TJedMain.LoadTemplates;
var tplname:string;
begin
 if IsMots then tplName:='mots.tpl' else tplName:='master.tpl';
 if (ProjectDir='') or (not FileExists(ProjectDir+tplname)) then
  templates.LoadFromFile(BaseDir+'jeddata\'+tplname) else
  templates.LoadFromFile(ProjectDir+tplname);
end;

Procedure TJedMain.SetMotsIndicator;
begin
if IsMots then
 begin
  PNProjType.Caption:='MOTS';
  PNProjType.Hint:='Current project is MOTS project (double-click to change)';
 end else
 begin
  PNProjType.Caption:='JK';
  PNProjType.Hint:='Current project is JK project (double-click to change)';
 end;
end;

procedure TJedMain.PNProjTypeDblClick(Sender: TObject);
begin
 SetMots(not isMots);
 SetMotsIndicator;
 LoadTemplates;
end;

procedure TJedMain.EpisodeEditor1Click(Sender: TObject);
begin
 EpisodeEdit.EditEpisode;
end;

Procedure TJedMain.MakeDoor;
var th:TJKThing;
var cg:TCOG;
    cf:TCOGFile;
    v:TCOgValue;
    tv:TTplValue;
    i:integer;
    nz:tvector;
    d:double;

Procedure AddTHValue(const name,vs:string);
begin
 tv:=TTPLValue.Create;
 th.Vals.Add(tv);
 tv.name:=name;
 tv.vtype:=GetTPLVType(tv.name);
 tv.atype:=GetTPLType(tv.name);
 tv.Val(vs);
end;

begin
 if map_mode<>MM_TH then
 begin
  ShowMessage('You must be in Thing mode');
  exit;
 end;
 th:=Level.Things[Cur_TH];

 i:=th.Vals.IndexOfName('numframes');
 if i<>-1 then
 begin
  ShowMessage('The thing appears to be a door already');
  exit;
 end;

 d:=th.bbox.z2-th.bbox.z1;
 if IsClose(d,0) then
 begin
  ShowMessage('The thing doesn''t have correct bounding box');
  exit;
 end;

 for i:=0 to th.vals.count-1 do th.vals[i].free;
 th.Vals.clear;

 AddTHValue('thingflags','0x408');
 AddTHValue('numframes','2');
 AddTHValue('frame',Format('(%.7g/%.7g/%.7g:%.7g/%.7g/%.7g)',
                    [th.x,th.y,th.z,th.pch,th.yaw,th.rol]));
 SetVec(nz,0,0,d);
 RotateVector(nz,th.pch,th.yaw,th.rol);
 AddTHValue('frame',Format('(%.7g/%.7g/%.7g:%.7g/%.7g/%.7g)',
                    [th.x+nz.dx,th.y+nz.dy,th.z+nz.dz,th.pch,th.yaw,th.rol]));


 cf:=TCogFile.Create;
 cg:=TCog.Create;
 cg.Name:='00_door.cog';
 Level.Cogs.Add(cg);
 cf.LoadNoLocals(cg.Name);
 for i:=0 to cf.count-1 do
 begin
  v:=TCOGvalue.Create;
  v.Assign(cf[i]);
  cg.Vals.Add(v);
  if i=0 then v.Val(IntToStr(th.Num)) else
   v.Val(cf[i].AsString);
  v.Resolve;
 end;
 cf.free;
 CogForm.RefreshList;
end;

procedure TJedMain.ExportSectoras3DO1Click(Sender: TObject);
var a3DO:T3DO;
    sec:TJKSector;
    fname:string;
    mesh:T3DOMesh;
    face:T3DOFace;
    n,i,j:integer;
    v:TVertex;
    jv:TJKVertex;
    jtv:TTXVertex;
    cx,cy,cz:double;

Function AddMat(const mat:string):integer;
var i:integer;
begin
 i:=a3Do.Mats.IndexOf(mat);
 if i<>-1 then Result:=i
 else Result:=a3Do.Mats.Add(mat);
end;

begin
 if Map_mode<>MM_SC then exit;
 if not Save3DO.Execute then exit;
 fname:=Save3DO.FileName;
 sec:=Level.Sectors[Cur_SC];
 a3DO:=T3Do.CreateNew;
 sec.Renumber;
 FindCenter(sec,cx,cy,cz);

 mesh:=a3Do.NewMesh; a3DO.Meshes.Add(mesh);
 mesh.Name:=ChangeFileExt(ExtractFilename(fname),'');

 {Add Vertices}
 for i:=0 to sec.vertices.count-1 do
 With sec.Vertices[i] do
 begin
  v:=TVertex.Create;
  v.x:=x-cx;
  v.y:=y-cy;
  v.z:=z-cz;
  Mesh.Vertices.Add(v);
 end;

 {Add Faces}
 for i:=0 to sec.Surfaces.count-1 do
 With sec.Surfaces[i] do
 begin
  face:=T3DOface.Create;
  face.imat:=AddMat(material);
  face.ftype:=0;
  face.geo:=geo;
  face.light:=light;
  face.tex:=tex;
  face.extra_l:=extraLight;
  for j:=vertices.count-1 downto 0 do
  begin
   jv:=vertices[j];
   jtv:=TXvertices[j];
   n:=face.AddVertex(mesh.vertices[jv.num]);
   With face.TXVertices[n] do
   begin
    u:=jtv.u;
    v:=jtv.v;
   end; 
  end;
  Mesh.Faces.Add(face);
 end;

a3Do.SaveToFile(fname);
a3Do.Free;

end;

procedure TJedMain.ReloadTemplates1Click(Sender: TObject);
begin
 LoadTemplates;
end;

Function TJedMain.ShortJKLName:string;
begin
 Result:=ChangeFileExt(ExtractFileName(LevelFile),'.jkl');
end;


procedure TJedMain.MakeaBackupCopy1Click(Sender: TObject);
var s:string;
begin
 if ProjectDir='' then
 begin
  ShowMessage('Save the level first');
  exit;
 end;
 {$i-}
  MkDir(ProjectDir+'backup');
  if ioresult<>0 then;
 {$i+}

end;


end.
